; XvCg\(Q[)

; G֌W

Enemy_Effect_Draw:
	ldy	EN_T,x
	lda	Xcn,y
	and	#$07
	tay
	lda	.jmp_l,y
	sta	<FNC_WORK
	lda	.jmp_h,y
	sta	<FNC_WORK+1
	jmp	[FNC_WORK]
.jmp_l:
	.db	LOW(.disappear), LOW(.none)
	.db	LOW(.none), LOW(.none)
	.db	LOW(.chapter), LOW(.none)
	.db	LOW(.none), LOW(.none)
.jmp_h:
	.db	HIGH(.disappear), HIGH(.none)
	.db	HIGH(.none), HIGH(.none)
	.db	HIGH(.chapter), HIGH(.none)
	.db	HIGH(.none), HIGH(.none)
.none:
	rts
.disappear:
	.if	0
	lda	<USR_CNT
	lsr	a
	ldy	EN_D,x
	bcs	.da1
	lda	#$fc
	sta	<FNC_ARG+2
	sta	<FNC_ARG+3
	lda	.da_pat,y
	ldy	PLC_COL2PAL+COL_BLUE
	jmp	Spr_PutEnemy
.da1:
	lda	#$fd
	sta	<FNC_ARG+2
	sta	<FNC_ARG+3
	ldx	.da_pat,y
	lda	PLC_COL2PAL+COL_BLUE
	ora	#$c0
	tay
	txa
	jmp	Spr_PutEnemy
.da_pat:
	.db	SP_DISAPPEAR+3,SP_DISAPPEAR+3
	.db	SP_DISAPPEAR+2,SP_DISAPPEAR+2
	.db	SP_DISAPPEAR+1,SP_DISAPPEAR+1
	.db	SP_DISAPPEAR,  SP_DISAPPEAR
	.else
	lda	EN_D,x
	asl	a
	eor	<USR_CNT
	and	#$fe
	eor	<USR_CNT
	tay
	lda	.xpos,y
	sta	<FNC_ARG+2
	lda	.ypos,y
	sta	<FNC_ARG+3
	lda	PLC_COL2PAL+COL_BLUE
	ora	.attr,y
	tay
	lda	#SP_DISAPPEAR2
	jmp	Spr_PutEnemy
.xpos:
	.db	-4-10, -4+10, -4+10, -4-10
	.db	-4-6, -4+6, -4+6, -4-6
	.db	-4-3, -4+3, -4+3, -4-3
	.db	-4-1, -4+1, -4+1, -4-1
.ypos:
	.db	-4-10, -4+10, -4-10, -4+10
	.db	-4-6, -4+6, -4-6, -4+6
	.db	-4-3, -4+3, -4-3, -4+3
	.db	-4-1, -4+1, -4-1, -4+1
.attr:
	.db	$00, $c0, $40, $80
	.db	$00, $c0, $40, $80
	.db	$00, $c0, $40, $80
	.db	$00, $c0, $40, $80
	.endif

.chapter:
	lda	#0
	ldy	EN_D,x
	cpy	#$41
	bcc	.cp1
	lda	.cp_delta-$41,y
.cp1:
	sta	<FNC_WORK+6

	lda	<FNC_ARG
	sta	<FNC_ARG+2
	lda	<FNC_ARG+1
	clc
	adc	<FNC_WORK+6
	sta	<FNC_ARG+3

	ldx	<ST_NUM
	lda	.cp_tbla_l,x
	ldy	.cp_tbla_h,x
	tax
	lda	PLC_COL2PAL+COL_BLUE
	jsr	Spr_Put2

	lda	<FNC_ARG
	clc
	adc	<FNC_WORK+6
	sta	<FNC_ARG+2
	lda	<FNC_ARG+1
	sta	<FNC_ARG+3

	ldx	<ST_NUM
	lda	.cp_tblb_l,x
	ldy	.cp_tblb_h,x
	tax
	lda	PLC_COL2PAL+COL_BLUE
	jmp	Spr_Put2
.cp_delta:
	.db	-1,-1, -2, -2, -3, -4, -5, -6
	.db	-7,-9,-10,-12,-13,-15,-16,-18
.cp_tbla_l:
	.db	LOW(.cp_pat1a), LOW(.cp_pat2a)
	.db	LOW(.cp_pat3a), LOW(.cp_pat4a)
.cp_tbla_h:
	.db	HIGH(.cp_pat1a), HIGH(.cp_pat2a)
	.db	HIGH(.cp_pat3a), HIGH(.cp_pat4a)
.cp_tblb_l:
	.db	LOW(.cp_pat1b), LOW(.cp_pat2b)
	.db	LOW(.cp_pat3b), LOW(.cp_pat4b)
.cp_tblb_h:
	.db	HIGH(.cp_pat1b), HIGH(.cp_pat2b)
	.db	HIGH(.cp_pat3b), HIGH(.cp_pat4b)
.cp_pat1a:
	.db	3, FNC_ARG+2, FNC_ARG+3
	.db	24-8, SP_CHAPTER,    $00, 12-24
	.db	24-8, SP_CHAPTER+ 1, $00, 12-16
	.db	24-8, SP_CHAPTER+ 2, $00, 12- 8
.cp_pat1b:
	.db	22, FNC_ARG+2, FNC_ARG+3
	.db	24-24, SP_CHAPTER+ 5, $00, 12+0
	.db	24-24, SP_CHAPTER+ 6, $00, 12+8
	.db	24-16, SP_CHAPTER+ 7, $00, 12+0
	.db	24-16, SP_CHAPTER+ 8, $00, 12+8
	.db	24- 8, SP_CHAPTER+ 9, $00, 12+0
	.db	24- 8, SP_CHAPTER+10, $00, 12+8
	.db	24+ 0, SP_CHAPTER+11, $00, 12+0
	.db	24+ 0, SP_CHAPTER+12, $00, 12+8
	.db	24+ 8, SP_CHAPTER+13, $00, 12+0
	.db	24+ 8, SP_CHAPTER+14, $00, 12+8
	.db	24+16, SP_CHAPTER+15, $00, 12+0
	.db	24+16, SP_CHAPTER+16, $00, 12+8
	.db	24+24, SP_CHAPTER+17, $00, 12+0
	.db	24+24, SP_CHAPTER+18, $00, 12+8
	.db	24+32, SP_CHAPTER+19, $00, 12+0
	.db	24+32, SP_CHAPTER+20, $00, 12+8
	.db	24+40, SP_CHAPTER+21, $00, 12+0
	.db	24+40, SP_CHAPTER+22, $00, 12+8
	.db	24+48, SP_CHAPTER+23, $00, 12+0
	.db	24+48, SP_CHAPTER+24, $00, 12+8
	.db	24+56, SP_CHAPTER+25, $00, 12+0
	.db	24+56, SP_CHAPTER+26, $00, 12+8
.cp_pat2a:
	.db	3, FNC_ARG+2, FNC_ARG+3
	.db	24-8, SP_CHAPTER,    $00, 12-24
	.db	24-8, SP_CHAPTER+ 1, $00, 12-16
	.db	24-8, SP_CHAPTER+ 3, $00, 12- 8
.cp_pat2b:
	.db	18, FNC_ARG+2, FNC_ARG+3
	.db	24-24, SP_CHAPTER+27, $00, 12+0
	.db	24-24, SP_CHAPTER+28, $00, 12+8
	.db	24-16, SP_CHAPTER+29, $00, 12+0
	.db	24-16, SP_CHAPTER+30, $00, 12+8
	.db	24- 8, SP_CHAPTER+31, $00, 12+0
	.db	24- 8, SP_CHAPTER+32, $00, 12+8
	.db	24+ 0, SP_CHAPTER+33, $00, 12+0
	.db	24+ 0, SP_CHAPTER+34, $00, 12+8
	.db	24+ 8, SP_CHAPTER+35, $00, 12+0
	.db	24+ 8, SP_CHAPTER+36, $00, 12+8
	.db	24+16, SP_CHAPTER+37, $00, 12+0
	.db	24+16, SP_CHAPTER+38, $00, 12+8
	.db	24+24, SP_CHAPTER+39, $00, 12+0
	.db	24+24, SP_CHAPTER+40, $00, 12+8
	.db	24+32, SP_CHAPTER+41, $00, 12+0
	.db	24+32, SP_CHAPTER+42, $00, 12+8
	.db	24+40, SP_CHAPTER+43, $00, 12+0
	.db	24+40, SP_CHAPTER+44, $00, 12+8
.cp_pat3a:
	.db	3, FNC_ARG+2, FNC_ARG+3
	.db	24-8, SP_CHAPTER,    $00, 12-24
	.db	24-8, SP_CHAPTER+ 1, $00, 12-16
	.db	24-8, SP_CHAPTER+ 4, $00, 12- 8
.cp_pat3b:
	.db	18, FNC_ARG+2, FNC_ARG+3
	.db	24-24, SP_CHAPTER+45, $00, 12+0
	.db	24-24, SP_CHAPTER+46, $00, 12+8
	.db	24-16, SP_CHAPTER+47, $00, 12+0
	.db	24-16, SP_CHAPTER+48, $00, 12+8
	.db	24- 8, SP_CHAPTER+49, $00, 12+0
	.db	24- 8, SP_CHAPTER+50, $00, 12+8
	.db	24+ 0, SP_CHAPTER+51, $00, 12+0
	.db	24+ 0, SP_CHAPTER+52, $00, 12+8
	.db	24+ 8, SP_CHAPTER+53, $00, 12+0
	.db	24+ 8, SP_CHAPTER+54, $00, 12+8
	.db	24+16, SP_CHAPTER+55, $00, 12+0
	.db	24+16, SP_CHAPTER+56, $00, 12+8
	.db	24+24, SP_CHAPTER+57, $00, 12+0
	.db	24+24, SP_CHAPTER+58, $00, 12+8
	.db	24+32, SP_CHAPTER+59, $00, 12+0
	.db	24+32, SP_CHAPTER+60, $00, 12+8
	.db	24+40, SP_CHAPTER+61, $00, 12+0
	.db	24+40, SP_CHAPTER+62, $00, 12+8
.cp_pat4a:
	.db	3, FNC_ARG+2, FNC_ARG+3
	.db	24-8, SP_CHAPTER,    $00, 12-24
	.db	24-8, SP_CHAPTER+ 1, $00, 12-16
	.db	24-8, SP_CHAPTER+ 2, $00, 12- 8
.cp_pat4b:
	.db	16, FNC_ARG+2, FNC_ARG+3
	.db	24-24, SP_CHAPTER+ 5, $00, 12+0
	.db	24-24, SP_CHAPTER+ 6, $00, 12+8
	.db	24-16, SP_CHAPTER+ 7, $00, 12+0
	.db	24-16, SP_CHAPTER+ 8, $00, 12+8
	.db	24- 8, SP_CHAPTER+ 9, $00, 12+0
	.db	24- 8, SP_CHAPTER+10, $00, 12+8
	.db	24+ 0, SP_CHAPTER+11, $00, 12+0
	.db	24+ 0, SP_CHAPTER+12, $00, 12+8
	.db	24+ 8, SP_CHAPTER+13, $00, 12+0
	.db	24+ 8, SP_CHAPTER+14, $00, 12+8
	.db	24+16, SP_CHAPTER+15, $00, 12+0
	.db	24+16, SP_CHAPTER+16, $00, 12+8
	.db	24+24, SP_CHAPTER+17, $00, 12+0
	.db	24+24, SP_CHAPTER+18, $00, 12+8
	.db	24+32, SP_CHAPTER+19, $00, 12+0
	.db	24+32, SP_CHAPTER+20, $00, 12+8

Enemy_Bubble_Draw:

	lda	<USR_CNT
	and	#$03
	tay

	lda	PLC_COL2PAL+COL_YELLOW
	ora	.attr,y
	sta	<FNC_WORK

	lda	.dxy,y
	sta	<FNC_ARG+2
	sta	<FNC_ARG+3
	lda	.pat,y
	ldy	<FNC_WORK
	jmp	Spr_PutEnemy
.pat:
	.db	SP_BUBBLE, SP_BUBBLE, SP_BUBBLE+1, SP_BUBBLE+1
.attr:
	.db	$00,$c0,$00,$c0
.dxy:
	.db	$fc,$fd,$fc,$fd

Enemy_Fairy_Draw:
	lda	EN_S,x
	and	#$0f
	tax
	and	#$0c
	tay
	lda	<USR_CNT
	and	#$01
	beq	.1
	iny
.1:
	lda	<USR_CNT
	and	#$20
	beq	.2
	iny
	iny
.2:
	lda	.dx,y
	sta	<FNC_ARG+2
	lda	.dy,y
	sta	<FNC_ARG+3
	lda	.pat,y
	ldy	.attr,x
	jmp	Spr_PutEnemy

.pat:
	.db	SP_FAIRY,   SP_FAIRY+1, SP_FAIRY+2, SP_FAIRY+3
	.db	SP_FAIRY+4, SP_FAIRY+5, SP_FAIRY+6, SP_FAIRY+7
	.db	SP_FAIRY+4, SP_FAIRY+5, SP_FAIRY+6, SP_FAIRY+7
.attr:
	.db	$00,$01,$02,$03
	.db	$00,$01,$02,$03
	.db	$40,$41,$42,$43
.dx:
	.db	$fc,$fd,$fc,$fd
	.db	$fc,$fc,$fc,$fc
	.db	$fd,$fd,$fd,$fd
.dy:
	.db	$fc,$fe,$fc,$fe
	.db	$fc,$fe,$fc,$fe
	.db	$fc,$fe,$fc,$fe

Enemy_Whirl_Draw:
	lda	EN_S,x
	sta	<FNC_WORK+1
	and	#$06
	lsr	a
;	clc
	adc	#SP_WHIRLWIND
	sta	<FNC_WORK

	lda	<USR_CNT
	and	#$03
	bne	.2
	lda	EN_S,x
;	clc
	adc	#2
	tay
	and	#$06
	cmp	#$06
	beq	.1
	lda	#$00
.1:
	eor	Int,y
	sta	EN_S,x
.2:

	lda	<FNC_WORK+1
	lsr	a
	and	#$04
	sta	<FNC_WORK+1
	lda	<USR_CNT
	rol	a
	and	#$03
	tax
	lda	.dx,x
	sta	<FNC_ARG+2
	lda	.dy,x
	sta	<FNC_ARG+3

	lda	PLC_COL2PAL+COL_BLUE
	ldy	<FNC_WORK+1
	beq	.3
	lda	PLC_COL2PAL+COL_RED
.3:
	ora	.attr,x
	tay

	lda	<FNC_WORK
	jmp	Spr_PutEnemy

.attr:
	.db	$40,$00,$80,$c0
.dx:
	.db	$fd,$fc,$fc,$fd
.dy:
	.db	$fc,$fc,$fd,$fd

Enemy_CircleFairy_Draw:
	stx	<FNC_WORK

	jsr	Enemy_Fairy_Draw
	beq	.1

	ldx	<TRI_CNT
	lda	.lo,x
	ldy	.hi,x
	ldx	<FNC_WORK
	jmp	Spr_PutBoss
.1:
	rts

.lo:
	.db	LOW(.data0),LOW(.data1),LOW(.data2)
.hi:
	.db	HIGH(.data0),HIGH(.data1),HIGH(.data2)
.data0:
	.db	2
	.db	24-8,SP_MGCIRCLE+1,$00+COL_BLUE,12-3
	.db	24+2,SP_MGCIRCLE+1,$80+COL_BLUE,12-3
.data1:
	.db	2
	.db	24-7,SP_MGCIRCLE+0,$00+COL_BLUE,12-9
	.db	24+1,SP_MGCIRCLE+0,$c0+COL_BLUE,12+2
.data2:
	.db	2
	.db	24-7,SP_MGCIRCLE+0,$40+COL_BLUE,12+2
	.db	24+1,SP_MGCIRCLE+0,$80+COL_BLUE,12-9

Enemy_Spark_Draw:
	lda	EN_S,x
	sta	<FNC_WORK
	tay
	lda	<USR_CNT
	and	#$07
	bne	.1
	iny
	iny
	tya
	and	#$f7
	sta	EN_S,x
.1:
	lda	<FNC_WORK
	and	#$07
	tay
	lda	<USR_CNT
	and	#$01
	ora	.inx,y
	tax
	lda	.dx,x
	sta	<FNC_ARG+2
	lda	.dy,x
	sta	<FNC_ARG+3

	lda	.attr,x
	ora	PLC_COL2PAL+COL_BLUE
	tay

	lda	#SP_SPARK
	cpx	#$04
	adc	#0
	jmp	Spr_PutEnemy
.inx:
	.db	0,2,2,0,4,6,6,4
.attr:
	.db	$00,$c0,$40,$80,$00,$c0,$80,$40
.dx:
	.db	-1,-6,-6,-1,-5,-2,-5,-2
.dy:
	.db	-5,-2,-5,-2,-6,-1,-1,-6

Enemy_AggFairy_Draw:
	lda	EN_S,x
	and	#$03
	tay
	lda	.pat2,y
	sta	<FNC_WORK+4
	ldx	.col1,y
	lda	PLC_COL2PAL,x
	sta	<FNC_WORK
	ldx	.col2,y
	cpy	#$02
	lda	<USR_CNT
	and	#$01
	tay
	beq	.1
	lda	#$40
.1:
	ora	PLC_COL2PAL,x
	sta	<FNC_WORK+1
	lda	.dx1,y
	sta	<FNC_WORK+2
	lda	.dx2,y
	sta	<FNC_WORK+3

	bcc	.2
	lda	Int+4,y
	tay
.2:
	lda	<USR_CNT
	and	#$10
	beq	.3
	iny
	iny
.3:
	lda	<FNC_WORK+2
	sta	<FNC_ARG+2
	lda	#-6
	sta	<FNC_ARG+3
	lda	Int+SP_FAIRY2,y
	ldy	<FNC_WORK
	jsr	Spr_PutEnemy

	lda	<FNC_WORK+3
	sta	<FNC_ARG+2
	lda	#-2
	sta	<FNC_ARG+3
	lda	<FNC_WORK+4
	ldy	<FNC_WORK+1
	jmp	Spr_PutEnemy
.pat2:
	.db	SP_FAIRY2+8, SP_FAIRY2+9, SP_FAIRY2+9, SP_FAIRY2+9
.col1:
	.db	COL_ENEMY1, COL_PINK, COL_YELLOW, COL_YELLOW
.col2:
	.db	COL_GREEN, COL_BLUE, COL_RED, COL_ENEMY1
.dx1:
	.db	-5,-2
.dx2:
	.db	-3,-4

Enemy_Alice_Draw:
	ldy	EN_Y,x
	sty	<FNC_WORK+6
	lda	EN_S,x
	and	#$1f
	sta	<FNC_WORK+1

	cmp	#$10
	bcs	.3
	cmp	#$08
	bcs	.5

	; stand & extend both
	sta	<FNC_WORK
	lda	<USR_CNT
	and	#$38
	cmp	#$20
	and	#$18
	beq	.2
	bcs	.1
	dey
.1:
	bcc	.2
	iny
.2:
	tya
	sta	EN_Y,x
	lda	<FNC_WORK
	jmp	.6
.3:
	; back rolling
	tay
	lda	<USR_CNT
	and	#$01
	bne	.4
	tya
;	sec
	sbc	#2
	eor	EN_S,x
	and	#$0e
	eor	EN_S,x
	sta	EN_S,x
.4:
	tya
;	sec
	adc	#10-16-1
	bne	.6	; same as jmp
.5:
	; side step
;	sec
	adc	#6-8-1
.6:
	eor	<USR_CNT
	and	#$fe
	eor	<USR_CNT

	stx	<FNC_WORK+7
	tax
	lda	.lo,x
	ldy	.hi,x
	ldx	<FNC_WORK+7
	lsr	<FNC_WORK+1
	jsr	Spr_PutBoss2

	ldx	<FNC_WORK+7
	lda	<FNC_WORK+6
	sta	EN_Y,x

	lda	EN_ST1_CMD+1
	beq	.7
	sta	EN_ST1_CMD
	lda	#$00
	sta	EN_ST1_CMD+1
.7:
	rts

.lo:
	.db	LOW(.data0), LOW(.data1)
	.db	LOW(.data2), LOW(.data3)
	.db	LOW(.data4), LOW(.data5)
	.db	LOW(.data6), LOW(.data7)
	.db	LOW(.data8), LOW(.data9)
	.db	LOW(.data10),LOW(.data11)
	.db	LOW(.data12),LOW(.data13)
	.db	LOW(.data14),LOW(.data15)
	.db	LOW(.data16),LOW(.data17)
	.db	LOW(.data18),LOW(.data19)
	.db	LOW(.data20),LOW(.data21)
	.db	LOW(.data22),LOW(.data23)
	.db	LOW(.data24),LOW(.data25)
.hi:
	.db	HIGH(.data0), HIGH(.data1)
	.db	HIGH(.data2), HIGH(.data3)
	.db	HIGH(.data4), HIGH(.data5)
	.db	HIGH(.data6), HIGH(.data7)
	.db	HIGH(.data8), HIGH(.data9)
	.db	HIGH(.data10),HIGH(.data11)
	.db	HIGH(.data12),HIGH(.data13)
	.db	HIGH(.data14),HIGH(.data15)
	.db	HIGH(.data16),HIGH(.data17)
	.db	HIGH(.data18),HIGH(.data19)
	.db	HIGH(.data20),HIGH(.data21)
	.db	HIGH(.data22),HIGH(.data23)
	.db	HIGH(.data24),HIGH(.data25)
.data0:
	.db	6
	.db	24- 6,SP_ALICE+ 0,$00+COL_PINK,  12-3
	.db	24-10,SP_ALICE+ 8,$00+COL_ENEMY1,12-4
	.db	24- 2,SP_ALICE+ 9,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_ALICE+30,$00+COL_BLUE,  12-4
	.db	24+ 4,SP_ALICE+33,$00+COL_BLUE,  12-2
	.db	24+ 8,SP_ALICE+57,$00+COL_ENEMY1,12-4
.data1:
	.db	6
	.db	24- 6,SP_ALICE+ 0,$00+COL_PINK,  12-3
	.db	24-10,SP_ALICE+ 8,$00+COL_ENEMY1,12-4
	.db	24- 2,SP_ALICE+ 9,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_ALICE+31,$00+COL_BLUE,  12-3
	.db	24+ 4,SP_ALICE+32,$00+COL_BLUE,  12-4
	.db	24+ 8,SP_ALICE+57,$00+COL_ENEMY1,12-4
.data2:
	.db	6
	.db	24- 6,SP_ALICE+ 1,$00+COL_PINK,  12-2
	.db	24-10,SP_ALICE+10,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_ALICE+13,$00+COL_ENEMY1,12+4
	.db	24- 4,SP_ALICE+30,$00+COL_BLUE,  12-4
	.db	24+ 4,SP_ALICE+33,$00+COL_BLUE,  12-2
	.db	24+ 8,SP_ALICE+57,$00+COL_ENEMY1,12-4
.data3:
	.db	6
	.db	24- 6,SP_ALICE+ 1,$00+COL_PINK,  12-2
	.db	24-10,SP_ALICE+11,$00+COL_ENEMY1,12-1
	.db	24- 5,SP_ALICE+12,$00+COL_ENEMY1,12-9
	.db	24- 4,SP_ALICE+31,$00+COL_BLUE,  12-3
	.db	24+ 4,SP_ALICE+32,$00+COL_BLUE,  12-4
	.db	24+ 8,SP_ALICE+57,$00+COL_ENEMY1,12-4
.data4:
	.db	6
	.db	24- 6,SP_ALICE+ 1,$00+COL_PINK,  12-2
	.db	24-10,SP_ALICE+14,$00+COL_ENEMY1,12-3
	.db	24- 6,SP_ALICE+17,$00+COL_ENEMY1,12+4
	.db	24- 4,SP_ALICE+30,$00+COL_BLUE,  12-4
	.db	24+ 4,SP_ALICE+33,$00+COL_BLUE,  12-2
	.db	24+ 8,SP_ALICE+57,$00+COL_ENEMY1,12-4
.data5:
	.db	6
	.db	24- 6,SP_ALICE+ 1,$00+COL_PINK,  12-2
	.db	24-10,SP_ALICE+15,$00+COL_ENEMY1,12-1
	.db	24- 7,SP_ALICE+16,$00+COL_ENEMY1,12-9
	.db	24- 4,SP_ALICE+31,$00+COL_BLUE,  12-3
	.db	24+ 4,SP_ALICE+32,$00+COL_BLUE,  12-4
	.db	24+ 8,SP_ALICE+57,$00+COL_ENEMY1,12-4
.data6:
	.db	6
	.db	24- 6,SP_ALICE+ 2,$00+COL_PINK,  12-2
	.db	24-10,SP_ALICE+18,$00+COL_ENEMY1,12-4
	.db	24- 3,SP_ALICE+20,$00+COL_ENEMY1,12-2
	.db	24- 4,SP_ALICE+34,$00+COL_BLUE,  12-5
	.db	24+ 2,SP_ALICE+37,$00+COL_BLUE,  12-3
	.db	24+ 8,SP_ALICE+58,$00+COL_ENEMY1,12-6
.data7:
	.db	6
	.db	24- 6,SP_ALICE+ 2,$00+COL_PINK,  12-2
	.db	24- 9,SP_ALICE+19,$00+COL_ENEMY1,12-3
	.db	24- 2,SP_ALICE+21,$00+COL_ENEMY1,12-1
	.db	24- 4,SP_ALICE+35,$00+COL_BLUE,  12-4
	.db	24+ 2,SP_ALICE+36,$00+COL_BLUE,  12-6
	.db	24+ 8,SP_ALICE+58,$00+COL_ENEMY1,12-6
.data8:
	.db	6
	.db	24- 5,SP_ALICE+ 3,$00+COL_PINK,  12+1
	.db	24-12,SP_ALICE+22,$00+COL_ENEMY1,12+1
	.db	24- 2,SP_ALICE+23,$00+COL_ENEMY1,12+7
	.db	24- 3,SP_ALICE+38,$00+COL_BLUE,  12-1
	.db	24- 2,SP_ALICE+39,$00+COL_BLUE,  12-5
	.db	24+ 4,SP_ALICE+59,$00+COL_ENEMY1,12-8
.data9:
	.db	6
	.db	24- 5,SP_ALICE+ 3,$00+COL_PINK,  12+1
	.db	24-12,SP_ALICE+22,$00+COL_ENEMY1,12+1
	.db	24- 2,SP_ALICE+23,$00+COL_ENEMY1,12+7
	.db	24- 3,SP_ALICE+38,$00+COL_BLUE,  12-1
	.db	24+ 2,SP_ALICE+40,$00+COL_BLUE,  12-2
	.db	24+ 4,SP_ALICE+59,$00+COL_ENEMY1,12-8
.data10:
	.db	6
	.db	24- 4,SP_ALICE+ 4,$00+COL_PINK,  12+0
	.db	24-11,SP_ALICE+22,$00+COL_ENEMY1,12+0
	.db	24- 2,SP_ALICE+13,$00+COL_ENEMY1,12+6
	.db	24- 3,SP_ALICE+41,$00+COL_BLUE,  12-3
	.db	24+ 0,SP_ALICE+44,$00+COL_BLUE,  12-2
	.db	24+ 3,SP_ALICE+60,$00+COL_ENEMY1,12-5
.data11:
	.db	6
	.db	24- 4,SP_ALICE+ 4,$00+COL_PINK,  12+0
	.db	24-11,SP_ALICE+22,$00+COL_ENEMY1,12+0
	.db	24- 2,SP_ALICE+13,$00+COL_ENEMY1,12+6
	.db	24- 3,SP_ALICE+42,$00+COL_BLUE,  12-2
	.db	24- 2,SP_ALICE+43,$00+COL_BLUE,  12-7
	.db	24+ 3,SP_ALICE+60,$00+COL_ENEMY1,12-5
.data12:
	.db	6
	.db	24- 7,SP_ALICE+ 5,$00+COL_PINK,  12-3
	.db	24-11,SP_ALICE+24,$00+COL_ENEMY1,12-6
	.db	24-12,SP_ALICE+25,$00+COL_ENEMY1,12+4
	.db	24- 4,SP_ALICE+45,$00+COL_BLUE,  12-3
	.db	24- 2,SP_ALICE+48,$00+COL_BLUE,  12+0
	.db	24+ 4,SP_ALICE+61,$00+COL_ENEMY1,12+1
.data13:
	.db	6
	.db	24- 7,SP_ALICE+ 5,$00+COL_PINK,  12-3
	.db	24-11,SP_ALICE+24,$00+COL_ENEMY1,12-6
	.db	24-12,SP_ALICE+25,$00+COL_ENEMY1,12+4
	.db	24- 3,SP_ALICE+46,$00+COL_BLUE,  12-2
	.db	24+ 0,SP_ALICE+47,$00+COL_BLUE,  12-5
	.db	24+ 4,SP_ALICE+61,$00+COL_ENEMY1,12+1
.data14:
	.db	6
	.db	24- 6,SP_ALICE+ 6,$00+COL_PINK,  12-4
	.db	24- 6,SP_ALICE+26,$00+COL_ENEMY1,12-11
	.db	24-12,SP_ALICE+27,$00+COL_ENEMY1,12-2
	.db	24- 3,SP_ALICE+49,$00+COL_BLUE,  12-3
	.db	24- 4,SP_ALICE+52,$00+COL_BLUE,  12+0
	.db	24- 1,SP_ALICE+62,$00+COL_ENEMY1,12+3
.data15:
	.db	6
	.db	24- 6,SP_ALICE+ 6,$00+COL_PINK,  12-4
	.db	24- 6,SP_ALICE+26,$00+COL_ENEMY1,12-11
	.db	24-12,SP_ALICE+27,$00+COL_ENEMY1,12-2
	.db	24- 4,SP_ALICE+50,$00+COL_BLUE,  12-3
	.db	24+ 1,SP_ALICE+51,$00+COL_BLUE,  12-2
	.db	24- 1,SP_ALICE+62,$00+COL_ENEMY1,12+3
.data16:
	.db	6
	.db	24- 3,SP_ALICE+ 7,$00+COL_PINK,  12-7
	.db	24+ 0,SP_ALICE+28,$00+COL_ENEMY1,12-11
	.db	24-10,SP_ALICE+29,$00+COL_ENEMY1,12-12
	.db	24- 3,SP_ALICE+53,$00+COL_BLUE,  12-4
	.db	24- 6,SP_ALICE+56,$00+COL_BLUE,  12-2
	.db	24- 7,SP_ALICE+63,$00+COL_ENEMY1,12+4
.data17:
	.db	6
	.db	24- 3,SP_ALICE+ 7,$00+COL_PINK,  12-7
	.db	24+ 0,SP_ALICE+28,$00+COL_ENEMY1,12-11
	.db	24-10,SP_ALICE+29,$00+COL_ENEMY1,12-12
	.db	24- 4,SP_ALICE+54,$00+COL_BLUE,  12-3
	.db	24- 1,SP_ALICE+55,$00+COL_BLUE,  12+0
	.db	24- 7,SP_ALICE+63,$00+COL_ENEMY1,12+4
.data18:
	.db	6
	.db	24- 2,SP_ALICE+ 4,$c0+COL_PINK,  12-6
	.db	24+ 5,SP_ALICE+22,$c0+COL_ENEMY1,12-6
	.db	24- 4,SP_ALICE+13,$c0+COL_ENEMY1,12-12
	.db	24- 3,SP_ALICE+41,$c0+COL_BLUE,  12-3
	.db	24- 6,SP_ALICE+44,$c0+COL_BLUE,  12-4
	.db	24- 9,SP_ALICE+60,$c0+COL_ENEMY1,12-1
.data19:
	.db	6
	.db	24- 2,SP_ALICE+ 4,$c0+COL_PINK,  12-6
	.db	24+ 5,SP_ALICE+22,$c0+COL_ENEMY1,12-6
	.db	24- 4,SP_ALICE+13,$c0+COL_ENEMY1,12-12
	.db	24- 3,SP_ALICE+42,$c0+COL_BLUE,  12-4
	.db	24- 4,SP_ALICE+43,$c0+COL_BLUE,  12+1
	.db	24- 9,SP_ALICE+60,$c0+COL_ENEMY1,12-1
.data20:
	.db	6
	.db	24+ 1,SP_ALICE+ 5,$c0+COL_PINK,  12-3
	.db	24+ 4,SP_ALICE+24,$c0+COL_ENEMY1,12+0
	.db	24+ 5,SP_ALICE+25,$c0+COL_ENEMY1,12-10
	.db	24- 2,SP_ALICE+45,$c0+COL_BLUE,  12-3
	.db	24- 5,SP_ALICE+48,$c0+COL_BLUE,  12-6
	.db	24-10,SP_ALICE+61,$c0+COL_ENEMY1,12-7
.data21:
	.db	6
	.db	24+ 1,SP_ALICE+ 5,$c0+COL_PINK,  12-3
	.db	24+ 5,SP_ALICE+24,$c0+COL_ENEMY1,12+0
	.db	24+ 6,SP_ALICE+25,$c0+COL_ENEMY1,12-10
	.db	24- 3,SP_ALICE+46,$c0+COL_BLUE,  12-4
	.db	24- 6,SP_ALICE+47,$c0+COL_BLUE,  12-1
	.db	24-10,SP_ALICE+61,$c0+COL_ENEMY1,12-7
.data22:
	.db	6
	.db	24+ 0,SP_ALICE+ 6,$c0+COL_PINK,  12-2
	.db	24+ 0,SP_ALICE+26,$c0+COL_ENEMY1,12+5
	.db	24+ 6,SP_ALICE+27,$c0+COL_ENEMY1,12-4
	.db	24- 3,SP_ALICE+49,$c0+COL_BLUE,  12-3
	.db	24- 2,SP_ALICE+52,$c0+COL_BLUE,  12-6
	.db	24- 5,SP_ALICE+62,$c0+COL_ENEMY1,12-9
.data23:
	.db	6
	.db	24+ 0,SP_ALICE+ 6,$c0+COL_PINK,  12-2
	.db	24+ 0,SP_ALICE+26,$c0+COL_ENEMY1,12+5
	.db	24+ 6,SP_ALICE+27,$c0+COL_ENEMY1,12-4
	.db	24- 2,SP_ALICE+50,$c0+COL_BLUE,  12-3
	.db	24- 7,SP_ALICE+51,$c0+COL_BLUE,  12-4
	.db	24- 5,SP_ALICE+62,$c0+COL_ENEMY1,12-9
.data24:
	.db	6
	.db	24- 3,SP_ALICE+ 7,$c0+COL_PINK,  12+1
	.db	24- 6,SP_ALICE+28,$c0+COL_ENEMY1,12+5
	.db	24+ 4,SP_ALICE+29,$c0+COL_ENEMY1,12+6
	.db	24- 3,SP_ALICE+53,$c0+COL_BLUE,  12-2
	.db	24+ 0,SP_ALICE+56,$c0+COL_BLUE,  12-4
	.db	24+ 1,SP_ALICE+63,$c0+COL_ENEMY1,12-10
.data25:
	.db	6
	.db	24- 3,SP_ALICE+ 7,$c0+COL_PINK,  12+1
	.db	24- 6,SP_ALICE+28,$c0+COL_ENEMY1,12+5
	.db	24+ 4,SP_ALICE+29,$c0+COL_ENEMY1,12+6
	.db	24- 2,SP_ALICE+54,$c0+COL_BLUE,  12-3
	.db	24- 5,SP_ALICE+55,$c0+COL_BLUE,  12-6
	.db	24+ 1,SP_ALICE+63,$c0+COL_ENEMY1,12-10

Enemy_Shanghai_Draw:
	lda	EN_S,x
	lsr	a
	and	#$07
	tay

	lda	<USR_CNT
	and	#$03
	bne	.1
	lda	.next,y
	eor	EN_S,x
	and	#$0e
	eor	EN_S,x
	sta	EN_S,x
.1:
	lda	.hi,y
	sta	<FNC_WORK
	lda	.lo,y
	ldy	<FNC_WORK
	jmp	Spr_PutBoss2
.next:
	.db	$00,$02,$06,$08,$0a,$0c,$0e,$04
.lo:
	.db	LOW(.data0), LOW(.data1)
	.db	LOW(.data0), LOW(.data1)
	.db	LOW(.data2), LOW(.data3)
	.db	LOW(.data4), LOW(.data5)
.hi:
	.db	HIGH(.data0), HIGH(.data1)
	.db	HIGH(.data0), HIGH(.data1)
	.db	HIGH(.data2), HIGH(.data3)
	.db	HIGH(.data4), HIGH(.data5)
.data0:
	.db	2
	.db	24-5,SP_SHANGHAI+0,$00+COL_ENEMY1,12-3
	.db	24+0,SP_SHANGHAI+1,$00+COL_BLUE,  12-3
.data1:
	.db	2
	.db	24-5,SP_SHANGHAI+2,$00+COL_ENEMY1,12-3
	.db	24+0,SP_SHANGHAI+3,$00+COL_BLUE,  12-3
.data2:
	.db	2
	.db	24-5,SP_SHANGHAI+6,$00+COL_ENEMY1,12-3
	.db	24+0,SP_SHANGHAI+7,$00+COL_BLUE,  12-3
.data3:
	.db	2
	.db	24-5,SP_SHANGHAI+4,$00+COL_ENEMY1,12-3
	.db	24+0,SP_SHANGHAI+5,$00+COL_BLUE,  12-3
.data4:
	.db	2
	.db	24-5,SP_SHANGHAI+6,$40+COL_ENEMY1,12-4
	.db	24+0,SP_SHANGHAI+7,$40+COL_BLUE,  12-4
.data5:
	.db	2
	.db	24-5,SP_SHANGHAI+2,$40+COL_ENEMY1,12-4
	.db	24+0,SP_SHANGHAI+3,$40+COL_BLUE,  12-4

Enemy_Hourai_Draw:
	lda	EN_S,x
	sta	<FNC_WORK

	eor	<USR_CNT
	and	#$fe
	eor	<USR_CNT
	and	#$03

	lsr	<FNC_WORK
	stx	<FNC_WORK
	tax
	lda	.lo,x
	ldy	.hi,x
	ldx	<FNC_WORK
	jmp	Spr_PutBoss2
.lo:
	.db	LOW(.data0), LOW(.data1)
	.db	LOW(.data2), LOW(.data3)
.hi:
	.db	HIGH(.data0), HIGH(.data1)
	.db	HIGH(.data2), HIGH(.data3)
.data0:
	.db	2
	.db	24-7,SP_HOURAI+0,$00+COL_ENEMY1,12-5
	.db	24+1,SP_HOURAI+1,$00+COL_ENEMY1,12-3
.data1:
	.db	2
	.db	24-7,SP_HOURAI+0,$40+COL_ENEMY1,12-2
	.db	24+1,SP_HOURAI+1,$00+COL_ENEMY1,12-3
.data2:
	.db	2
	.db	24-7,SP_HOURAI+2,$00+COL_ENEMY1,12-2
	.db	24+1,SP_HOURAI+4,$00+COL_ENEMY1,12-3
.data3:
	.db	2
	.db	24-7,SP_HOURAI+3,$00+COL_ENEMY1,12-4
	.db	24+1,SP_HOURAI+4,$00+COL_ENEMY1,12-3

Enemy_Cirno_Draw:
	stx	<FNC_WORK
	lda	EN_S,x
	lsr	a

	lda	<USR_CNT
	and	#$01

	tax
	lda	.lo,x
	ldy	.hi,x
	ldx	<FNC_WORK
	jmp	Spr_PutBoss2

.lo:
	.db	LOW(.data0), LOW(.data1)
.hi:
	.db	HIGH(.data0), HIGH(.data1)
.data0:
	.db	4
	.db	24-10,SP_CIRNO+0,$00+COL_ENEMY1,12-2
	.db	24- 3,SP_CIRNO+1,$00+COL_ENEMY1,12-5
	.db	24- 2,SP_CIRNO+3,$00+COL_BLUE,  12-3
	.db	24+ 4,SP_CIRNO+5,$00+COL_BLUE,  12-3
.data1:
	.db	4
	.db	24-10,SP_CIRNO+0,$00+COL_ENEMY1,12-2
	.db	24- 3,SP_CIRNO+2,$00+COL_ENEMY1,12-1
	.db	24- 2,SP_CIRNO+3,$00+COL_BLUE,  12-3
	.db	24+ 4,SP_CIRNO+4,$00+COL_BLUE,  12-5

Enemy_Letty_Draw:
	lda	EN_S,x
	sta	<FNC_WORK

	and	#$07
	cmp	#$06
	bcs	.1
	cmp	#$04
	bcs	.4
	cmp	#$02
	bcs	.3

	ldy	#LOW(.lo0-.lo0)
	lda	<USR_CNT
	lsr	a
	lsr	a
	jmp	.2
.1:
	ldy	#LOW(.lo3-.lo0)
	lda	<USR_CNT
.2:
	and	#$08
	lsr	a
	lsr	a
;	clc
	adc	Int,y
	bcc	.5	; same as jmp
.3:
	lda	#LOW(.lo1-.lo0)
	bne	.5	; same as jmp
.4:
	lda	#LOW(.lo2-.lo0)
.5:
	eor	<USR_CNT
	and	#$fe
	eor	<USR_CNT

	lsr	<FNC_WORK
	stx	<FNC_WORK
	tax
	lda	.lo0,x
	ldy	.hi0,x
	ldx	<FNC_WORK
	jmp	Spr_PutBoss2

.lo0:
	.db	LOW(.data0), LOW(.data1)
	.db	LOW(.data2), LOW(.data3)
.lo1:
	.db	LOW(.data4), LOW(.data5)
.lo2:
	.db	LOW(.data6), LOW(.data7)
.lo3:
	.db	LOW(.data8), LOW(.data9)
	.db	LOW(.data10),LOW(.data11)

.hi0:
	.db	HIGH(.data0), HIGH(.data1)
	.db	HIGH(.data2), HIGH(.data3)
.hi1:
	.db	HIGH(.data4), HIGH(.data5)
.hi2:
	.db	HIGH(.data6), HIGH(.data7)
.hi3:
	.db	HIGH(.data8), HIGH(.data9)
	.db	HIGH(.data10),HIGH(.data11)

.data0:
	.db	5
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-3
	.db	24- 1,SP_LETTY+ 4,$00+COL_ENEMY1,12-4
	.db	24+ 4,SP_LETTY+ 8,$00+COL_ENEMY1,12-2
	.db	24- 6,SP_LETTY+16,$00+COL_BLUE,  12-3
	.db	24+ 1,SP_LETTY+24,$00+COL_BLUE,  12-5
.data1:
	.db	5
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-3
	.db	24- 1,SP_LETTY+ 4,$00+COL_ENEMY1,12-4
	.db	24+ 4,SP_LETTY+ 9,$00+COL_ENEMY1,12-3
	.db	24- 6,SP_LETTY+16,$00+COL_BLUE,  12-3
	.db	24+ 1,SP_LETTY+25,$00+COL_BLUE,  12-1
.data2:
	.db	5
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-3
	.db	24- 1,SP_LETTY+ 5,$00+COL_ENEMY1,12-4
	.db	24+ 4,SP_LETTY+ 8,$00+COL_ENEMY1,12-2
	.db	24- 6,SP_LETTY+16,$00+COL_BLUE,  12-3
	.db	24+ 1,SP_LETTY+26,$00+COL_BLUE,  12-5
.data3:
	.db	5
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-3
	.db	24- 1,SP_LETTY+ 5,$00+COL_ENEMY1,12-4
	.db	24+ 4,SP_LETTY+ 9,$00+COL_ENEMY1,12-3
	.db	24- 6,SP_LETTY+16,$00+COL_BLUE,  12-3
	.db	24+ 1,SP_LETTY+27,$00+COL_BLUE,  12-1
.data4:
	.db	5
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-1
	.db	24- 5,SP_LETTY+ 6,$00+COL_ENEMY1,12-1
	.db	24+ 4,SP_LETTY+10,$00+COL_ENEMY1,12-3
	.db	24- 6,SP_LETTY+17,$00+COL_BLUE,  12-4
	.db	24+ 1,SP_LETTY+28,$00+COL_BLUE,  12-6
.data5:
	.db	5
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-1
	.db	24- 5,SP_LETTY+ 7,$00+COL_ENEMY1,12+0
	.db	24+ 4,SP_LETTY+10,$00+COL_ENEMY1,12-3
	.db	24- 6,SP_LETTY+17,$00+COL_BLUE,  12-4
	.db	24+ 1,SP_LETTY+29,$00+COL_BLUE,  12-2
.data6:
	.db	5
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-3
	.db	24- 5,SP_LETTY+ 3,$00+COL_ENEMY1,12-7
	.db	24+ 4,SP_LETTY+14,$00+COL_ENEMY1,12+1
	.db	24- 6,SP_LETTY+22,$00+COL_BLUE,  12-2
	.db	24+ 1,SP_LETTY+34,$00+COL_BLUE,  12-5
.data7:
	.db	5
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-3
	.db	24- 5,SP_LETTY+ 3,$40+COL_ENEMY1,12+0
	.db	24+ 4,SP_LETTY+13,$00+COL_ENEMY1,12-7
	.db	24- 6,SP_LETTY+23,$00+COL_BLUE,  12-5
	.db	24+ 1,SP_LETTY+35,$00+COL_BLUE,  12-1
.data8:
	.db	6
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-3
	.db	24- 5,SP_LETTY+ 1,$00+COL_ENEMY1,12-9
	.db	24- 1,SP_LETTY+ 4,$00+COL_ENEMY1,12-4
	.db	24+ 4,SP_LETTY+12,$00+COL_ENEMY1,12+1
	.db	24- 6,SP_LETTY+18,$00+COL_BLUE,  12-2
	.db	24+ 1,SP_LETTY+30,$00+COL_BLUE,  12-5
.data9:
	.db	6
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-3
	.db	24- 5,SP_LETTY+ 1,$40+COL_ENEMY1,12+2
	.db	24- 1,SP_LETTY+ 4,$00+COL_ENEMY1,12-4
	.db	24+ 4,SP_LETTY+11,$00+COL_ENEMY1,12-7
	.db	24- 6,SP_LETTY+19,$00+COL_BLUE,  12-5
	.db	24+ 1,SP_LETTY+31,$00+COL_BLUE,  12-1
.data10:
	.db	6
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-3
	.db	24- 5,SP_LETTY+ 2,$00+COL_ENEMY1,12-9
	.db	24- 1,SP_LETTY+ 5,$00+COL_ENEMY1,12-4
	.db	24+ 4,SP_LETTY+12,$00+COL_ENEMY1,12+1
	.db	24- 6,SP_LETTY+20,$00+COL_BLUE,  12-2
	.db	24+ 1,SP_LETTY+32,$00+COL_BLUE,  12-5
.data11:
	.db	6
	.db	24-14,SP_LETTY+ 0,$00+COL_ENEMY1,12-3
	.db	24- 5,SP_LETTY+ 2,$40+COL_ENEMY1,12+2
	.db	24- 1,SP_LETTY+ 5,$00+COL_ENEMY1,12-4
	.db	24+ 4,SP_LETTY+11,$00+COL_ENEMY1,12-7
	.db	24- 6,SP_LETTY+21,$00+COL_BLUE,  12-5
	.db	24+ 1,SP_LETTY+33,$00+COL_BLUE,  12-1

Enemy_Chen_Draw:
	lda	EN_S,x
	sta	<FNC_WORK
	and	#$1f
	cmp	#$02
	bcs	.1
	lda	<SPR_INX
	rts
.1:
	cmp	#$14
	bcc	.2
	eor	#$10
.2:
	cmp	#$08
	bcs	.6
	cmp	#$06
	bcs	.4
	cmp	#$04
	bcs	.3

	; stand
	ldy	<USR_CNT
	lda	Xcn,y
	and	#$02
	jmp	.7
.3:
	; rolling
	.db	$24	; bit <$b8 (set v-flag)
.4:
	; reverse rolling
	clv
	ldy	<TRI_CNT
	lda	<USR_CNT
	asl	a
	and	#$0e
	ora	Xcn,y
	lsr	a
	bvs	.5
	eor	#$1f
;	clc
	adc	#$f8	; -8
.5:
	tay
	lda	.roll,y
	bne	.7	; same as jmp
.6:
	; side step & crouch &
	; lift hand & extend both
;	sec
	adc	#$fb	; -4
.7:
	eor	<USR_CNT
	and	#$fe
	eor	<USR_CNT

	lsr	<FNC_WORK
	stx	<FNC_WORK
	tax
	lda	.lo0,x
	ldy	.hi0,x
	ldx	<FNC_WORK
	jmp	Spr_PutBoss2
.roll:
	.db	16,22,28,18,24,30,20,26
	.db	26,16,22,28,18,24,30,20
	.db	20,26,16,22,28,18,24,30
.lo0:
	.db	LOW(.data0), LOW(.data1)
	.db	LOW(.data2), LOW(.data3)
.lo1:
	.db	LOW(.data12),LOW(.data13)
.lo2:
	.db	LOW(.data14),LOW(.data15)
.lo3:
	.db	LOW(.data4), LOW(.data5)
.lo4:
	.db	LOW(.data6), LOW(.data7)
.lo5:
	.db	LOW(.data8), LOW(.data9)
.lo6:
	.db	LOW(.data10),LOW(.data11)
.lo7:
	.db	LOW(.data14),LOW(.data15)
	.db	LOW(.data16),LOW(.data17)
	.db	LOW(.data18),LOW(.data19)
	.db	LOW(.data20),LOW(.data21)
	.db	LOW(.data22),LOW(.data23)
	.db	LOW(.data24),LOW(.data25)
	.db	LOW(.data26),LOW(.data27)
	.db	LOW(.data28),LOW(.data29)

.hi0:
	.db	HIGH(.data0), HIGH(.data1)
	.db	HIGH(.data2), HIGH(.data3)
.hi1:
	.db	HIGH(.data12),HIGH(.data13)
.hi2:
	.db	HIGH(.data14),HIGH(.data15)
.hi3:
	.db	HIGH(.data4), HIGH(.data5)
.hi4:
	.db	HIGH(.data6), HIGH(.data7)
.hi5:
	.db	HIGH(.data8), HIGH(.data9)
.hi6:
	.db	HIGH(.data10),HIGH(.data11)
.hi7:
	.db	HIGH(.data14),HIGH(.data15)
	.db	HIGH(.data16),HIGH(.data17)
	.db	HIGH(.data18),HIGH(.data19)
	.db	HIGH(.data20),HIGH(.data21)
	.db	HIGH(.data22),HIGH(.data23)
	.db	HIGH(.data24),HIGH(.data25)
	.db	HIGH(.data26),HIGH(.data27)
	.db	HIGH(.data28),HIGH(.data29)

.data0:
	.db	5
	.db	24-11,SP_CHEN+ 0,$00+COL_GREEN, 12-3
	.db	24-11,SP_CHEN+ 4,$00+COL_ENEMY1,12-4
	.db	24- 3,SP_CHEN+10,$00+COL_RED,   12-3
	.db	24- 5,SP_CHEN+21,$00+COL_ENEMY1,12-4
	.db	24+ 2,SP_CHEN+24,$40+COL_ENEMY1,12-5
.data1:
	.db	5
	.db	24-11,SP_CHEN+ 0,$00+COL_GREEN, 12-3
	.db	24-11,SP_CHEN+ 4,$40+COL_ENEMY1,12-3
	.db	24- 3,SP_CHEN+ 9,$00+COL_RED,   12-4
	.db	24- 5,SP_CHEN+21,$00+COL_ENEMY1,12-4
	.db	24+ 2,SP_CHEN+24,$00+COL_ENEMY1,12-2
.data2:
	.db	5
	.db	24-11,SP_CHEN+ 0,$00+COL_GREEN, 12-3
	.db	24-11,SP_CHEN+ 4,$00+COL_ENEMY1,12-4
	.db	24- 3,SP_CHEN+12,$00+COL_RED,   12-2
	.db	24- 5,SP_CHEN+21,$00+COL_ENEMY1,12-3
	.db	24+ 2,SP_CHEN+24,$40+COL_ENEMY1,12-5
.data3:
	.db	5
	.db	24-11,SP_CHEN+ 0,$00+COL_GREEN, 12-3
	.db	24-11,SP_CHEN+ 4,$40+COL_ENEMY1,12-3
	.db	24- 3,SP_CHEN+11,$00+COL_RED,   12-3
	.db	24- 5,SP_CHEN+21,$00+COL_ENEMY1,12-3
	.db	24+ 2,SP_CHEN+24,$00+COL_ENEMY1,12-2
.data4:
	.db	5
	.db	24-11,SP_CHEN+ 1,$00+COL_GREEN, 12-3
	.db	24-11,SP_CHEN+ 5,$00+COL_ENEMY1,12-4
	.db	24- 3,SP_CHEN+14,$00+COL_RED,   12-3
	.db	24- 5,SP_CHEN+21,$00+COL_ENEMY1,12-5
	.db	24+ 2,SP_CHEN+24,$40+COL_ENEMY1,12-5
.data5:
	.db	5
	.db	24-11,SP_CHEN+ 1,$00+COL_GREEN, 12-3
	.db	24-11,SP_CHEN+ 6,$00+COL_ENEMY1,12-3
	.db	24- 3,SP_CHEN+13,$00+COL_RED,   12-4
	.db	24- 5,SP_CHEN+21,$00+COL_ENEMY1,12-5
	.db	24+ 2,SP_CHEN+24,$00+COL_ENEMY1,12-2
.data6:
	.db	5
	.db	24-11,SP_CHEN+ 2,$00+COL_GREEN, 12-3
	.db	24-11,SP_CHEN+ 7,$00+COL_ENEMY1,12-4
	.db	24- 3,SP_CHEN+16,$00+COL_RED,   12-3
	.db	24- 6,SP_CHEN+22,$00+COL_ENEMY1,12-6
	.db	24+ 2,SP_CHEN+24,$40+COL_ENEMY1,12-5
.data7:
	.db	5
	.db	24-11,SP_CHEN+ 2,$00+COL_GREEN, 12-3
	.db	24-11,SP_CHEN+ 8,$00+COL_ENEMY1,12-3
	.db	24- 3,SP_CHEN+15,$00+COL_RED,   12-4
	.db	24- 6,SP_CHEN+22,$00+COL_ENEMY1,12-6
	.db	24+ 2,SP_CHEN+24,$00+COL_ENEMY1,12-2
.data8:
	.db	5
	.db	24-11,SP_CHEN+ 0,$00+COL_GREEN, 12-3
	.db	24-11,SP_CHEN+ 4,$00+COL_ENEMY1,12-4
	.db	24- 3,SP_CHEN+18,$00+COL_RED,   12-3
	.db	24- 6,SP_CHEN+22,$00+COL_ENEMY1,12-6
	.db	24+ 2,SP_CHEN+24,$40+COL_ENEMY1,12-5
.data9:
	.db	5
	.db	24-11,SP_CHEN+ 0,$00+COL_GREEN, 12-3
	.db	24-11,SP_CHEN+ 4,$40+COL_ENEMY1,12-3
	.db	24- 3,SP_CHEN+17,$00+COL_RED,   12-4
	.db	24- 6,SP_CHEN+22,$40+COL_ENEMY1,12-1
	.db	24+ 2,SP_CHEN+24,$00+COL_ENEMY1,12-2
.data10:
	.db	5
	.db	24-11,SP_CHEN+ 3,$40+COL_GREEN, 12-4
	.db	24-11,SP_CHEN+ 4,$00+COL_ENEMY1,12-4
	.db	24- 3,SP_CHEN+20,$00+COL_RED,   12-3
	.db	24- 6,SP_CHEN+23,$00+COL_ENEMY1,12-6
	.db	24+ 2,SP_CHEN+24,$40+COL_ENEMY1,12-5
.data11:
	.db	5
	.db	24-11,SP_CHEN+ 3,$00+COL_GREEN, 12-3
	.db	24-11,SP_CHEN+ 4,$40+COL_ENEMY1,12-3
	.db	24- 3,SP_CHEN+19,$00+COL_RED,   12-4
	.db	24- 6,SP_CHEN+23,$40+COL_ENEMY1,12-1
	.db	24+ 2,SP_CHEN+24,$00+COL_ENEMY1,12-2
.data12:
	.db	5
	.db	24- 9,SP_CHEN+25,$00+COL_GREEN, 12-5
	.db	24-11,SP_CHEN+30,$00+COL_ENEMY1,12-5
	.db	24- 3,SP_CHEN+37,$00+COL_RED,   12-1
	.db	24- 4,SP_CHEN+46,$00+COL_ENEMY1,12-2
	.db	24+ 4,SP_CHEN+47,$00+COL_ENEMY1,12-1
.data13:
	.db	5
	.db	24- 9,SP_CHEN+25,$00+COL_GREEN, 12-5
	.db	24-11,SP_CHEN+30,$00+COL_ENEMY1,12-5
	.db	24- 3,SP_CHEN+36,$00+COL_RED,   12-3
	.db	24- 4,SP_CHEN+46,$00+COL_ENEMY1,12-2
	.db	24+ 4,SP_CHEN+47,$00+COL_ENEMY1,12-1
.data14:
	.db	4
	.db	24- 7,SP_CHEN+26,$00+COL_GREEN, 12-5
	.db	24- 9,SP_CHEN+30,$00+COL_ENEMY1,12-5
	.db	24- 2,SP_CHEN+39,$00+COL_RED,   12-1
	.db	24+ 1,SP_CHEN+49,$00+COL_ENEMY1,12-3
.data15:
	.db	4
	.db	24- 7,SP_CHEN+26,$00+COL_GREEN, 12-5
	.db	24- 9,SP_CHEN+30,$00+COL_ENEMY1,12-5
	.db	24- 1,SP_CHEN+38,$00+COL_RED,   12-4
	.db	24+ 1,SP_CHEN+48,$00+COL_ENEMY1,12-2
.data16:
	.db	4
	.db	24- 6,SP_CHEN+27,$00+COL_GREEN, 12-6
	.db	24- 7,SP_CHEN+31,$00+COL_ENEMY1,12-8
	.db	24- 4,SP_CHEN+41,$00+COL_RED,   12+0
	.db	24- 2,SP_CHEN+50,$00+COL_ENEMY1,12+0
.data17:
	.db	4
	.db	24- 6,SP_CHEN+27,$00+COL_GREEN, 12-6
	.db	24- 5,SP_CHEN+32,$00+COL_ENEMY1,12-6
	.db	24- 1,SP_CHEN+40,$00+COL_RED,   12-1
	.db	24- 2,SP_CHEN+51,$00+COL_ENEMY1,12+2
.data18:
	.db	4
	.db	24- 2,SP_CHEN+28,$00+COL_GREEN, 12-7
	.db	24- 2,SP_CHEN+33,$00+COL_ENEMY1,12-9
	.db	24- 6,SP_CHEN+43,$00+COL_RED,   12-2
	.db	24- 4,SP_CHEN+53,$00+COL_ENEMY1,12+1
.data19:
	.db	4
	.db	24- 2,SP_CHEN+28,$00+COL_GREEN, 12-7
	.db	24- 2,SP_CHEN+33,$00+COL_ENEMY1,12-9
	.db	24- 3,SP_CHEN+42,$00+COL_RED,   12-1
	.db	24- 5,SP_CHEN+52,$00+COL_ENEMY1,12+1
.data20:
	.db	4
	.db	24- 1,SP_CHEN+29,$00+COL_GREEN, 12-6
	.db	24+ 1,SP_CHEN+34,$00+COL_ENEMY1,12-7
	.db	24- 7,SP_CHEN+45,$00+COL_RED,   12-4
	.db	24- 7,SP_CHEN+54,$00+COL_ENEMY1,12-2
.data21:
	.db	4
	.db	24- 1,SP_CHEN+29,$00+COL_GREEN, 12-6
	.db	24- 1,SP_CHEN+35,$00+COL_ENEMY1,12-5
	.db	24- 6,SP_CHEN+44,$00+COL_RED,   12-1
	.db	24- 9,SP_CHEN+55,$00+COL_ENEMY1,12-2
.data22:
	.db	4
	.db	24+ 0,SP_CHEN+26,$c0+COL_GREEN, 12-2
	.db	24+ 2,SP_CHEN+30,$c0+COL_ENEMY1,12-2
	.db	24- 5,SP_CHEN+39,$c0+COL_RED,   12-6
	.db	24- 8,SP_CHEN+49,$c0+COL_ENEMY1,12-4
.data23:
	.db	4
	.db	24+ 0,SP_CHEN+26,$c0+COL_GREEN, 12-2
	.db	24+ 2,SP_CHEN+30,$c0+COL_ENEMY1,12-2
	.db	24- 6,SP_CHEN+38,$c0+COL_RED,   12-3
	.db	24- 8,SP_CHEN+48,$c0+COL_ENEMY1,12-5
.data24:
	.db	4
	.db	24- 1,SP_CHEN+27,$c0+COL_GREEN, 12-1
	.db	24+ 0,SP_CHEN+31,$c0+COL_ENEMY1,12+1
	.db	24- 3,SP_CHEN+51,$c0+COL_RED,   12-7
	.db	24- 5,SP_CHEN+50,$c0+COL_ENEMY1,12-7
.data25:
	.db	4
	.db	24- 1,SP_CHEN+27,$c0+COL_GREEN, 12-1
	.db	24- 2,SP_CHEN+32,$c0+COL_ENEMY1,12-1
	.db	24- 6,SP_CHEN+40,$c0+COL_RED,   12-6
	.db	24- 5,SP_CHEN+51,$c0+COL_ENEMY1,12-9
.data26:
	.db	4
	.db	24- 5,SP_CHEN+28,$c0+COL_GREEN, 12+0
	.db	24- 5,SP_CHEN+33,$c0+COL_ENEMY1,12+2
	.db	24- 1,SP_CHEN+43,$c0+COL_RED,   12-5
	.db	24- 3,SP_CHEN+53,$c0+COL_ENEMY1,12-8
.data27:
	.db	4
	.db	24- 5,SP_CHEN+28,$c0+COL_GREEN, 12+0
	.db	24- 5,SP_CHEN+33,$c0+COL_ENEMY1,12+2
	.db	24- 4,SP_CHEN+42,$c0+COL_RED,   12-6
	.db	24- 2,SP_CHEN+52,$c0+COL_ENEMY1,12-8
.data28:
	.db	4
	.db	24- 6,SP_CHEN+29,$c0+COL_GREEN, 12-1
	.db	24- 8,SP_CHEN+34,$c0+COL_ENEMY1,12+0
	.db	24+ 0,SP_CHEN+45,$c0+COL_RED,   12-3
	.db	24+ 0,SP_CHEN+54,$c0+COL_ENEMY1,12-5
.data29:
	.db	4
	.db	24- 6,SP_CHEN+29,$c0+COL_GREEN, 12-1
	.db	24- 6,SP_CHEN+35,$c0+COL_ENEMY1,12-2
	.db	24- 1,SP_CHEN+44,$c0+COL_RED,   12-6
	.db	24+ 2,SP_CHEN+55,$c0+COL_ENEMY1,12-5

Enemy_Youmu_Draw:
	lda	EN_S,x
	sta	<FNC_WORK
	and	#$1f
	cmp	#$18
	bcs	.4
	cmp	#$02
	bcs	.2

	; stand
	ldy	<USR_CNT
	lda	Xcn,y
	and	#$02
	bcc	.5	; same as jmp

	; swing a sword
.2:
	lsr	a
	tay
	lda	<TRI_CNT
	bne	.3
	lda	<USR_CNT
	lsr	a
	bcs	.3
	dec	EN_S,x
	dec	EN_S,x
.3:
	lda	.swing-1,y
	bne	.5	; same as jmp

	; side step & lift hand & guard
.4:
;	sec
	sbc	#$0a
.5:
	eor	<USR_CNT
	and	#$fe
	eor	<USR_CNT

	lsr	<FNC_WORK
	stx	<FNC_WORK
	tax
	lda	.lo0,x
	ldy	.hi0,x
	ldx	<FNC_WORK
	jmp	Spr_PutBoss2
.swing:
	.db	$0c,$0a,$0a,$0a,$0a,$0a,$0a,$08
	.db	$06,$04,$04
.lo0:
	.db	LOW(.data0), LOW(.data1)
	.db	LOW(.data2), LOW(.data3)
.lo1:
	.db	LOW(.data4), LOW(.data5)
	.db	LOW(.data6), LOW(.data7)
	.db	LOW(.data8), LOW(.data9)
	.db	LOW(.data10),LOW(.data11)
	.db	LOW(.data12),LOW(.data13)
.lo2:
	.db	LOW(.data14),LOW(.data15)
	.db	LOW(.data16),LOW(.data17)
	.db	LOW(.data4), LOW(.data5)
	.db	LOW(.data12),LOW(.data13)
.hi0:
	.db	HIGH(.data0), HIGH(.data1)
	.db	HIGH(.data2), HIGH(.data3)
.hi1:
	.db	HIGH(.data4), HIGH(.data5)
	.db	HIGH(.data6), HIGH(.data7)
	.db	HIGH(.data8), HIGH(.data9)
	.db	HIGH(.data10),HIGH(.data11)
	.db	HIGH(.data12),HIGH(.data13)
.hi2:
	.db	HIGH(.data14),HIGH(.data15)
	.db	HIGH(.data16),HIGH(.data17)
	.db	HIGH(.data4), HIGH(.data5)
	.db	HIGH(.data12),HIGH(.data13)
.data0:
	.db	7
	.db	24-12,SP_YOUMU+ 0,$00+COL_ENEMY1,12-4
	.db	24- 4,SP_YOUMU+ 4,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_YOUMU+12,$00+COL_GREEN, 12-4
	.db	24+ 4,SP_YOUMU+16,$00+COL_ENEMY1,12-3
	.db	24+ 4,SP_YOUMU+28,$00+COL_GREEN, 12-3
	.db	24- 1,SP_YOUMU+36,$00+COL_ENEMY1,12-10
	.db	24+ 1,SP_YOUMU+42,$00+COL_GREEN, 12-10
.data1:
	.db	7
	.db	24-12,SP_YOUMU+ 0,$00+COL_ENEMY1,12-4
	.db	24- 4,SP_YOUMU+ 4,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_YOUMU+12,$00+COL_GREEN, 12-4
	.db	24+ 4,SP_YOUMU+16,$00+COL_ENEMY1,12-3
	.db	24+ 4,SP_YOUMU+28,$00+COL_GREEN, 12-3
	.db	24- 1,SP_YOUMU+40,$00+COL_GREEN, 12-10
	.db	24+ 1,SP_YOUMU+38,$00+COL_ENEMY1,12-10
.data2:
	.db	7
	.db	24-12,SP_YOUMU+ 0,$00+COL_ENEMY1,12-4
	.db	24- 4,SP_YOUMU+ 5,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_YOUMU+12,$00+COL_GREEN, 12-4
	.db	24+ 4,SP_YOUMU+17,$00+COL_ENEMY1,12-3
	.db	24+ 4,SP_YOUMU+29,$00+COL_GREEN, 12-3
	.db	24- 1,SP_YOUMU+37,$00+COL_ENEMY1,12-10
	.db	24+ 1,SP_YOUMU+43,$00+COL_GREEN, 12-10
.data3:
	.db	7
	.db	24-12,SP_YOUMU+ 0,$00+COL_ENEMY1,12-4
	.db	24- 4,SP_YOUMU+ 5,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_YOUMU+12,$00+COL_GREEN, 12-4
	.db	24+ 4,SP_YOUMU+17,$00+COL_ENEMY1,12-3
	.db	24+ 4,SP_YOUMU+29,$00+COL_GREEN, 12-3
	.db	24- 1,SP_YOUMU+41,$00+COL_GREEN, 12-10
	.db	24+ 1,SP_YOUMU+39,$00+COL_ENEMY1,12-10
.data4:
	.db	10
	.db	24-12,SP_YOUMU2+ 0,$00+COL_ENEMY1,12-4
	.db	24- 4,SP_YOUMU2+ 4,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_YOUMU2+16,$00+COL_GREEN, 12-3
	.db	24+ 4,SP_YOUMU2+24,$00+COL_ENEMY1,12-3
	.db	24+ 4,SP_YOUMU2+32,$00+COL_GREEN, 12-3
	.db	24-17,SP_YOUMU2+40,$00+COL_ENEMY1,12-11
	.db	24- 9,SP_YOUMU2+41,$00+COL_ENEMY1,12-11
	.db	24- 1,SP_YOUMU2+42,$00+COL_ENEMY1,12-11
	.db	24+ 0,SP_YOUMU2+49,$00+COL_GREEN, 12-11
	.db	24-19,SP_YOUMU2+50,$00+COL_GREEN, 12-3
.data5:
	.db	9
	.db	24-12,SP_YOUMU2+ 0,$00+COL_ENEMY1,12-4
	.db	24- 4,SP_YOUMU2+ 4,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_YOUMU2+16,$00+COL_GREEN, 12-3
	.db	24+ 4,SP_YOUMU2+24,$00+COL_ENEMY1,12-3
	.db	24+ 4,SP_YOUMU2+32,$00+COL_GREEN, 12-3
	.db	24-10,SP_YOUMU2+48,$00+COL_GREEN, 12-11
	.db	24- 1,SP_YOUMU2+42,$00+COL_ENEMY1,12-11
	.db	24+ 0,SP_YOUMU2+49,$00+COL_GREEN, 12-11
	.db	24-19,SP_YOUMU2+43,$00+COL_ENEMY1,12-3
.data6:
	.db	11
	.db	24-12,SP_YOUMU2+ 1,$00+COL_ENEMY1,12-2
	.db	24- 4,SP_YOUMU2+ 5,$00+COL_ENEMY1,12-6
	.db	24- 4,SP_YOUMU2+ 6,$00+COL_ENEMY1,12+2
	.db	24- 5,SP_YOUMU2+17,$00+COL_GREEN, 12-7
	.db	24- 5,SP_YOUMU2+18,$00+COL_GREEN, 12+1
	.db	24+ 4,SP_YOUMU2+25,$00+COL_ENEMY1,12-7
	.db	24+ 4,SP_YOUMU2+26,$00+COL_ENEMY1,12+1
	.db	24+ 4,SP_YOUMU2+33,$00+COL_GREEN, 12-7
	.db	24+ 4,SP_YOUMU2+34,$00+COL_GREEN, 12+1
	.db	24-17,SP_YOUMU2+51,$00+COL_GREEN, 12-7
	.db	24-12,SP_YOUMU2+45,$00+COL_ENEMY1,12-11
.data7:
	.db	10
	.db	24-12,SP_YOUMU2+ 1,$00+COL_ENEMY1,12-2
	.db	24- 4,SP_YOUMU2+ 5,$00+COL_ENEMY1,12-6
	.db	24- 4,SP_YOUMU2+ 6,$00+COL_ENEMY1,12+2
	.db	24- 5,SP_YOUMU2+17,$00+COL_GREEN, 12-7
	.db	24- 5,SP_YOUMU2+18,$00+COL_GREEN, 12+1
	.db	24+ 4,SP_YOUMU2+25,$00+COL_ENEMY1,12-7
	.db	24+ 4,SP_YOUMU2+26,$00+COL_ENEMY1,12+1
	.db	24+ 4,SP_YOUMU2+33,$00+COL_GREEN, 12-7
	.db	24+ 4,SP_YOUMU2+34,$00+COL_GREEN, 12+1
	.db	24-17,SP_YOUMU2+44,$00+COL_ENEMY1,12-7
.data8:
	.db	12
	.db	24-12,SP_YOUMU2+ 2,$00+COL_ENEMY1,12+0
	.db	24- 4,SP_YOUMU2+ 7,$00+COL_ENEMY1,12-1
	.db	24- 4,SP_YOUMU2+ 8,$00+COL_ENEMY1,12+7
	.db	24- 3,SP_YOUMU2+ 9,$00+COL_ENEMY1,12+15
	.db	24- 8,SP_YOUMU2+19,$00+COL_GREEN, 12-4
	.db	24- 8,SP_YOUMU2+20,$00+COL_GREEN, 12+4
	.db	24+ 0,SP_YOUMU2+21,$00+COL_GREEN, 12+12
	.db	24+ 4,SP_YOUMU2+27,$00+COL_ENEMY1,12-7
	.db	24+ 4,SP_YOUMU2+28,$00+COL_ENEMY1,12+1
	.db	24+ 4,SP_YOUMU2+35,$00+COL_GREEN, 12-3
	.db	24+ 5,SP_YOUMU2+36,$00+COL_GREEN, 12+5
	.db	24-17,SP_YOUMU2+51,$00+COL_GREEN, 12-5
.data9:
	.db	12
	.db	24-12,SP_YOUMU2+ 2,$00+COL_ENEMY1,12+0
	.db	24- 4,SP_YOUMU2+ 7,$00+COL_ENEMY1,12-1
	.db	24- 4,SP_YOUMU2+ 8,$00+COL_ENEMY1,12+7
	.db	24- 3,SP_YOUMU2+ 9,$00+COL_ENEMY1,12+15
	.db	24- 8,SP_YOUMU2+19,$00+COL_GREEN, 12-4
	.db	24- 8,SP_YOUMU2+20,$00+COL_GREEN, 12+4
	.db	24+ 0,SP_YOUMU2+21,$00+COL_GREEN, 12+12
	.db	24+ 4,SP_YOUMU2+27,$00+COL_ENEMY1,12-7
	.db	24+ 4,SP_YOUMU2+28,$00+COL_ENEMY1,12+1
	.db	24+ 4,SP_YOUMU2+35,$00+COL_GREEN, 12-3
	.db	24+ 5,SP_YOUMU2+36,$00+COL_GREEN, 12+5
	.db	24-17,SP_YOUMU2+44,$00+COL_ENEMY1,12-5
.data10:
	.db	11
	.db	24-12,SP_YOUMU2+ 2,$00+COL_ENEMY1,12+0
	.db	24- 4,SP_YOUMU2+10,$00+COL_ENEMY1,12-1
	.db	24- 4,SP_YOUMU2+11,$00+COL_ENEMY1,12+7
	.db	24- 3,SP_YOUMU2+12,$00+COL_ENEMY1,12+13
	.db	24- 8,SP_YOUMU2+19,$00+COL_GREEN, 12-4
	.db	24- 8,SP_YOUMU2+20,$00+COL_GREEN, 12+4
	.db	24+ 4,SP_YOUMU2+27,$00+COL_ENEMY1,12-7
	.db	24+ 4,SP_YOUMU2+28,$00+COL_ENEMY1,12+1
	.db	24+ 4,SP_YOUMU2+35,$00+COL_GREEN, 12-3
	.db	24+ 5,SP_YOUMU2+36,$00+COL_GREEN, 12+5
	.db	24-17,SP_YOUMU2+51,$00+COL_GREEN, 12-5
.data11:
	.db	11
	.db	24-12,SP_YOUMU2+ 2,$00+COL_ENEMY1,12+0
	.db	24- 4,SP_YOUMU2+10,$00+COL_ENEMY1,12-1
	.db	24- 4,SP_YOUMU2+11,$00+COL_ENEMY1,12+7
	.db	24- 8,SP_YOUMU2+19,$00+COL_GREEN, 12-4
	.db	24- 8,SP_YOUMU2+20,$00+COL_GREEN, 12+4
	.db	24+ 0,SP_YOUMU2+21,$00+COL_GREEN, 12+12
	.db	24+ 4,SP_YOUMU2+27,$00+COL_ENEMY1,12-7
	.db	24+ 4,SP_YOUMU2+28,$00+COL_ENEMY1,12+1
	.db	24+ 4,SP_YOUMU2+35,$00+COL_GREEN, 12-3
	.db	24+ 5,SP_YOUMU2+36,$00+COL_GREEN, 12+5
	.db	24-17,SP_YOUMU2+44,$00+COL_ENEMY1,12-5
.data12:
	.db	10
	.db	24-12,SP_YOUMU2+ 3,$00+COL_ENEMY1,12-2
	.db	24- 4,SP_YOUMU2+13,$00+COL_ENEMY1,12-6
	.db	24- 4,SP_YOUMU2+14,$00+COL_ENEMY1,12+2
	.db	24- 5,SP_YOUMU2+22,$00+COL_GREEN, 12-7
	.db	24- 5,SP_YOUMU2+18,$00+COL_GREEN, 12+1
	.db	24+ 4,SP_YOUMU2+25,$00+COL_ENEMY1,12-7
	.db	24+ 4,SP_YOUMU2+26,$00+COL_ENEMY1,12+1
	.db	24+ 4,SP_YOUMU2+33,$00+COL_GREEN, 12-7
	.db	24+ 4,SP_YOUMU2+34,$00+COL_GREEN, 12+1
	.db	24- 4,SP_YOUMU2+52,$00+COL_GREEN, 12-15
.data13:
	.db	10
	.db	24-12,SP_YOUMU2+ 3,$00+COL_ENEMY1,12-2
	.db	24- 4,SP_YOUMU2+13,$00+COL_ENEMY1,12-6
	.db	24- 4,SP_YOUMU2+14,$00+COL_ENEMY1,12+2
	.db	24- 5,SP_YOUMU2+22,$00+COL_GREEN, 12-7
	.db	24- 5,SP_YOUMU2+18,$00+COL_GREEN, 12+1
	.db	24+ 4,SP_YOUMU2+25,$00+COL_ENEMY1,12-7
	.db	24+ 4,SP_YOUMU2+26,$00+COL_ENEMY1,12+1
	.db	24+ 4,SP_YOUMU2+33,$00+COL_GREEN, 12-7
	.db	24+ 4,SP_YOUMU2+34,$00+COL_GREEN, 12+1
	.db	24- 4,SP_YOUMU2+46,$00+COL_ENEMY1,12-15
.data14:
	.db	7
	.db	24-12,SP_YOUMU+ 0,$00+COL_ENEMY1,12-2
	.db	24- 4,SP_YOUMU+ 6,$00+COL_ENEMY1,12-7
	.db	24- 4,SP_YOUMU+ 7,$00+COL_ENEMY1,12+1
	.db	24- 4,SP_YOUMU+13,$00+COL_GREEN, 12-2
	.db	24+ 4,SP_YOUMU+18,$00+COL_ENEMY1,12-6
	.db	24+ 4,SP_YOUMU+19,$00+COL_ENEMY1,12+2
	.db	24+ 3,SP_YOUMU+31,$00+COL_GREEN, 12-6
.data15:
	.db	8
	.db	24-12,SP_YOUMU+ 0,$00+COL_ENEMY1,12-2
	.db	24- 4,SP_YOUMU+ 6,$00+COL_ENEMY1,12-7
	.db	24- 4,SP_YOUMU+ 7,$00+COL_ENEMY1,12+1
	.db	24- 4,SP_YOUMU+13,$00+COL_GREEN, 12-2
	.db	24+ 4,SP_YOUMU+20,$00+COL_ENEMY1,12-7
	.db	24+ 4,SP_YOUMU+21,$00+COL_ENEMY1,12+1
	.db	24+ 4,SP_YOUMU+30,$00+COL_GREEN, 12-4
	.db	24+ 4,SP_YOUMU+32,$00+COL_GREEN, 12+1
.data16:
	.db	6
	.db	24-12,SP_YOUMU+ 1,$00+COL_ENEMY1,12-2
	.db	24- 4,SP_YOUMU+ 8,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_YOUMU+14,$00+COL_GREEN, 12-2
	.db	24+ 4,SP_YOUMU+22,$00+COL_ENEMY1,12-3
	.db	24+ 4,SP_YOUMU+34,$00+COL_GREEN, 12-7
	.db	24+ 4,SP_YOUMU+35,$00+COL_GREEN, 12+1
.data17:
	.db	6
	.db	24-12,SP_YOUMU+ 1,$00+COL_ENEMY1,12-2
	.db	24- 4,SP_YOUMU+ 9,$00+COL_ENEMY1,12-1
	.db	24- 4,SP_YOUMU+14,$00+COL_GREEN, 12-2
	.db	24+ 4,SP_YOUMU+23,$00+COL_ENEMY1,12-7
	.db	24+ 4,SP_YOUMU+24,$00+COL_ENEMY1,12+1
	.db	24+ 4,SP_YOUMU+33,$00+COL_GREEN, 12-3

Enemy_Ran_Draw:
	lda	EN_S,x
	and	#$1f
	sta	<FNC_WORK
	cmp	#$02
	bcs	.1
	jmp	.invisible
.1:
	ldy	EN_Y,x
	sty	<FNC_WORK+6
	stx	<FNC_WORK+7

	cmp	#$0c
	bcs	.8
	cmp	#$08
	bcs	.5
;	cmp	#$04
;	bcs	.4

	; stand
	lda	<USR_CNT
	and	#$38
	cmp	#$20
	and	#$18
	beq	.3
	bcs	.2
	dey
.2:
	bcc	.3
	iny
.3:
	tya
	sta	EN_Y,x
	lda	<FNC_WORK
	sec
.4:
	; invoke
;	sec
	sbc	#2
	bcs	.12	; same as jmp
.5:
	; crouch
	ldy	<TRI_CNT
	bne	.7
	cmp	#$0a
	bcc	.6
	ldy	#$0e
.6:
	sty	EN_RAN_ROLLCNT
	lda	EN_S,x
	eor	#$04
	sta	EN_S,x
.7:
	lda	#$04
	bne	.12	; same as jmp
.8:
	cmp	#$0e
	bcs	.9
	; rolling
	.db	$24	; bit <$b8 (set v-flag)
.9:
	; reverse rolling
	clv
	ldy	EN_RAN_ROLLCNT
	lda	<TRI_CNT
	bne	.10
	lda	Int+2,y
	and	#$0e
	sta	EN_RAN_ROLLCNT
.10:
	tya
	bvs	.11
	eor	#$0e
.11:
;	clc
	adc	#6
.12:
	eor	<USR_CNT
	and	#$fe
	eor	<USR_CNT

	lsr	<FNC_WORK
	tax
	lda	.lo,x
	ldy	.hi,x
	ldx	<FNC_WORK+7
	jsr	Spr_PutBoss2

	ldx	<FNC_WORK+7
	lda	<FNC_WORK+6
	sta	EN_Y,x
	rts
.invisible:
	lda	$bfff
	sta	<FNC_WORK+6

	lda	<USR_CNT
	lsr	a
	lda	<TRI_CNT
	rol	a
	tay
	lda	.angle,y
	sta	<FNC_WORK+5
	lda	#3
	sta	<FNC_WORK+4
	stx	<FNC_WORK+3
.21:
	lda	EN_RAN_INVCNT
	cmp	#48
	bcc	.22
	lda	#48
.22:
	asl	a
;	clc
	adc	#48
	ldy	<FNC_WORK+5
	jsr	Util_GetRadius

	lda	EN_X,x
	asl	<FNC_ARG+2
	adc	<FNC_ARG
	sta	<FNC_ARG
	lda	EN_Y,x
	asl	<FNC_ARG+3
	adc	<FNC_ARG+1
	sta	<FNC_ARG+1

	lda	#SP_RAN+63
	ldy	PLC_COL2PAL+COL_YELLOW
	jsr	Spr_PutShot2
	ldx	<FNC_WORK+3

	lda	<FNC_WORK+5
	clc
	adc	#$40
	sta	<FNC_WORK+5
	dec	<FNC_WORK+4
	bpl	.21

	lda	<FNC_WORK+6
	jmp	SetPrgBankB
.angle:
	.db	$00, $2b, $15, $20, $0b, $35
.lo:
	.db	LOW(.data0), LOW(.data1)
	.db	LOW(.data2), LOW(.data3)
	.db	LOW(.data4), LOW(.data4)
	.db	LOW(.data6), LOW(.data7)
	.db	LOW(.data8), LOW(.data9)
	.db	LOW(.data10),LOW(.data11)
	.db	LOW(.data12),LOW(.data13)
	.db	LOW(.data14),LOW(.data15)
	.db	LOW(.data16),LOW(.data17)
	.db	LOW(.data18),LOW(.data19)
	.db	LOW(.data20),LOW(.data21)
.hi:
	.db	HIGH(.data0), HIGH(.data1)
	.db	HIGH(.data2), HIGH(.data3)
	.db	HIGH(.data4), HIGH(.data4)
	.db	HIGH(.data6), HIGH(.data7)
	.db	HIGH(.data8), HIGH(.data9)
	.db	HIGH(.data10),HIGH(.data11)
	.db	HIGH(.data12),HIGH(.data13)
	.db	HIGH(.data14),HIGH(.data15)
	.db	HIGH(.data16),HIGH(.data17)
	.db	HIGH(.data18),HIGH(.data19)
	.db	HIGH(.data20),HIGH(.data21)
.data0:
	.db	8
	.db	24-12,SP_RAN+ 0,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_RAN+ 1,$00+COL_ENEMY1,12-3
	.db	24+ 4,SP_RAN+ 2,$00+COL_ENEMY1,12-5
	.db	24-12,SP_RAN+ 3,$00+COL_YELLOW,12-3
	.db	24- 4,SP_RAN+ 4,$00+COL_YELLOW,12-5
	.db	24+ 4,SP_RAN+ 5,$00+COL_YELLOW,12-5
	.db	24- 7,SP_RAN+ 6,$00+COL_YELLOW,12+3
	.db	24+ 1,SP_RAN+ 8,$00+COL_YELLOW,12+3
.data1:
	.db	8
	.db	24-12,SP_RAN+ 0,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_RAN+ 1,$00+COL_ENEMY1,12-3
	.db	24+ 4,SP_RAN+ 2,$00+COL_ENEMY1,12-5
	.db	24-12,SP_RAN+ 3,$00+COL_YELLOW,12-3
	.db	24- 4,SP_RAN+ 4,$00+COL_YELLOW,12-5
	.db	24+ 4,SP_RAN+ 5,$00+COL_YELLOW,12-5
	.db	24- 6,SP_RAN+ 7,$00+COL_YELLOW,12+3
	.db	24+ 2,SP_RAN+ 9,$00+COL_YELLOW,12+3
.data2:
	.db	8
	.db	24-12,SP_RAN+10,$00+COL_ENEMY1,12-5
	.db	24- 4,SP_RAN+11,$00+COL_ENEMY1,12-5
	.db	24+ 4,SP_RAN+12,$00+COL_ENEMY1,12-3
	.db	24-12,SP_RAN+13,$00+COL_YELLOW,12-4
	.db	24- 6,SP_RAN+14,$00+COL_YELLOW,12-8
	.db	24- 4,SP_RAN+16,$00+COL_YELLOW,12+0
	.db	24+ 2,SP_RAN+18,$00+COL_YELLOW,12-8
	.db	24+ 4,SP_RAN+19,$40+COL_YELLOW,12+0
.data3:
	.db	8
	.db	24-12,SP_RAN+10,$00+COL_ENEMY1,12-5
	.db	24- 4,SP_RAN+11,$00+COL_ENEMY1,12-5
	.db	24+ 4,SP_RAN+12,$00+COL_ENEMY1,12-3
	.db	24-12,SP_RAN+13,$00+COL_YELLOW,12-4
	.db	24- 4,SP_RAN+15,$00+COL_YELLOW,12-7
	.db	24- 6,SP_RAN+17,$00+COL_YELLOW,12+1
	.db	24+ 4,SP_RAN+19,$00+COL_YELLOW,12-7
	.db	24+ 2,SP_RAN+18,$40+COL_YELLOW,12+1
.data4:
	.db	8
	.db	24-12,SP_RAN+20,$00+COL_ENEMY1,12-3
	.db	24- 4,SP_RAN+21,$00+COL_ENEMY1,12-3
	.db	24+ 4,SP_RAN+22,$00+COL_ENEMY1,12-3
	.db	24-12,SP_RAN+23,$00+COL_YELLOW,12-5
	.db	24- 4,SP_RAN+24,$00+COL_YELLOW,12-5
	.db	24+ 4,SP_RAN+25,$00+COL_YELLOW,12-5
	.db	24- 7,SP_RAN+26,$00+COL_YELLOW,12+3
	.db	24+ 1,SP_RAN+27,$00+COL_YELLOW,12+3
.data6:
	.db	7
	.db	24- 8,SP_RAN+28,$00+COL_ENEMY1,12-5
	.db	24+ 0,SP_RAN+29,$00+COL_ENEMY1,12-5
	.db	24+ 0,SP_RAN+30,$00+COL_ENEMY1,12+3
	.db	24- 7,SP_RAN+32,$00+COL_YELLOW,12-7
	.db	24+ 1,SP_RAN+33,$00+COL_YELLOW,12-5
	.db	24- 8,SP_RAN+34,$00+COL_YELLOW,12+1
	.db	24+ 0,SP_RAN+35,$00+COL_YELLOW,12+3
.data7:
	.db	7
	.db	24- 8,SP_RAN+28,$00+COL_ENEMY1,12-5
	.db	24+ 0,SP_RAN+29,$00+COL_ENEMY1,12-5
	.db	24-15,SP_RAN+31,$00+COL_YELLOW,12-8
	.db	24- 7,SP_RAN+32,$00+COL_YELLOW,12-7
	.db	24+ 1,SP_RAN+33,$00+COL_YELLOW,12-5
	.db	24- 8,SP_RAN+34,$00+COL_YELLOW,12+1
	.db	24+ 0,SP_RAN+35,$00+COL_YELLOW,12+3
.data8:
	.db	7
	.db	24- 7,SP_RAN+36,$00+COL_ENEMY1,12-8
	.db	24- 2,SP_RAN+37,$00+COL_ENEMY1,12-1
	.db	24- 6,SP_RAN+38,$00+COL_YELLOW,12-10
	.db	24- 5,SP_RAN+40,$00+COL_YELLOW,12-2
	.db	24+ 3,SP_RAN+41,$00+COL_BLUE,  12-2
	.db	24- 5,SP_RAN+42,$00+COL_YELLOW,12+6
	.db	24+ 3,SP_RAN+43,$00+COL_YELLOW,12+7
.data9:
	.db	7
	.db	24- 7,SP_RAN+36,$00+COL_ENEMY1,12-8
	.db	24- 2,SP_RAN+37,$00+COL_ENEMY1,12-1
	.db	24- 6,SP_RAN+38,$00+COL_YELLOW,12-10
	.db	24-13,SP_RAN+39,$00+COL_YELLOW,12-5
	.db	24- 5,SP_RAN+40,$00+COL_YELLOW,12-2
	.db	24+ 3,SP_RAN+41,$00+COL_BLUE,  12-2
	.db	24- 5,SP_RAN+42,$00+COL_YELLOW,12+6
.data10:
	.db	7
	.db	24- 2,SP_RAN+44,$00+COL_ENEMY1,12-7
	.db	24- 2,SP_RAN+45,$00+COL_ENEMY1,12+1
	.db	24-10,SP_RAN+46,$00+COL_ENEMY1,12+1
	.db	24+ 0,SP_RAN+48,$00+COL_YELLOW,12-6
	.db	24- 2,SP_RAN+49,$00+COL_YELLOW,12+2
	.db	24- 8,SP_RAN+50,$00+COL_YELLOW,12-7
	.db	24-10,SP_RAN+51,$00+COL_YELLOW,12+1
.data11:
	.db	7
	.db	24- 2,SP_RAN+44,$00+COL_ENEMY1,12-7
	.db	24- 2,SP_RAN+45,$00+COL_ENEMY1,12+1
	.db	24+ 1,SP_RAN+47,$00+COL_YELLOW,12-14
	.db	24+ 0,SP_RAN+48,$00+COL_YELLOW,12-6
	.db	24- 2,SP_RAN+49,$00+COL_YELLOW,12+2
	.db	24- 8,SP_RAN+50,$00+COL_YELLOW,12-7
	.db	24-10,SP_RAN+51,$00+COL_YELLOW,12+1
.data12:
	.db	7
	.db	24+ 1,SP_RAN+52,$00+COL_ENEMY1,12-6
	.db	24- 6,SP_RAN+53,$00+COL_ENEMY1,12-1
	.db	24+ 3,SP_RAN+54,$00+COL_YELLOW,12-5
	.db	24- 5,SP_RAN+56,$00+COL_YELLOW,12-4
	.db	24- 5,SP_RAN+57,$00+COL_BLUE,  12+4
	.db	24-13,SP_RAN+58,$00+COL_YELLOW,12-4
	.db	24-14,SP_RAN+59,$00+COL_YELLOW,12+4
.data13:
	.db	7
	.db	24+ 1,SP_RAN+52,$00+COL_ENEMY1,12-6
	.db	24- 6,SP_RAN+53,$00+COL_ENEMY1,12-1
	.db	24+ 3,SP_RAN+54,$00+COL_YELLOW,12-5
	.db	24- 2,SP_RAN+55,$00+COL_YELLOW,12-12
	.db	24- 5,SP_RAN+56,$00+COL_YELLOW,12-4
	.db	24- 5,SP_RAN+57,$00+COL_BLUE,  12+4
	.db	24-13,SP_RAN+58,$00+COL_YELLOW,12-4
.data14:
	.db	7
	.db	24+ 1,SP_RAN+28,$c0+COL_ENEMY1,12-2
	.db	24- 7,SP_RAN+29,$c0+COL_ENEMY1,12-2
	.db	24- 7,SP_RAN+30,$c0+COL_ENEMY1,12-10
	.db	24+ 0,SP_RAN+32,$c0+COL_YELLOW,12+0
	.db	24- 8,SP_RAN+33,$c0+COL_YELLOW,12-2
	.db	24+ 1,SP_RAN+34,$c0+COL_YELLOW,12-8
	.db	24- 7,SP_RAN+35,$c0+COL_YELLOW,12-10
.data15:
	.db	7
	.db	24+ 1,SP_RAN+28,$c0+COL_ENEMY1,12-2
	.db	24- 7,SP_RAN+29,$c0+COL_ENEMY1,12-2
	.db	24+ 8,SP_RAN+31,$c0+COL_YELLOW,12+1
	.db	24+ 0,SP_RAN+32,$c0+COL_YELLOW,12+0
	.db	24- 8,SP_RAN+33,$c0+COL_YELLOW,12-2
	.db	24+ 1,SP_RAN+34,$c0+COL_YELLOW,12-8
	.db	24- 7,SP_RAN+35,$c0+COL_YELLOW,12-10
.data16:
	.db	7
	.db	24+ 0,SP_RAN+36,$c0+COL_ENEMY1,12+1
	.db	24- 5,SP_RAN+37,$c0+COL_ENEMY1,12-6
	.db	24- 1,SP_RAN+38,$c0+COL_YELLOW,12+3
	.db	24- 2,SP_RAN+40,$c0+COL_YELLOW,12-5
	.db	24-10,SP_RAN+41,$c0+COL_BLUE,  12-5
	.db	24- 2,SP_RAN+42,$c0+COL_YELLOW,12-13
	.db	24-10,SP_RAN+43,$c0+COL_YELLOW,12-14
.data17:
	.db	7
	.db	24+ 0,SP_RAN+36,$c0+COL_ENEMY1,12+1
	.db	24- 5,SP_RAN+37,$c0+COL_ENEMY1,12-6
	.db	24- 1,SP_RAN+38,$c0+COL_YELLOW,12+3
	.db	24+ 6,SP_RAN+39,$c0+COL_YELLOW,12-2
	.db	24- 2,SP_RAN+40,$c0+COL_YELLOW,12-5
	.db	24-10,SP_RAN+41,$c0+COL_BLUE,  12-5
	.db	24- 2,SP_RAN+42,$c0+COL_YELLOW,12-13
.data18:
	.db	7
	.db	24- 5,SP_RAN+44,$c0+COL_ENEMY1,12+0
	.db	24- 5,SP_RAN+45,$c0+COL_ENEMY1,12-8
	.db	24+ 3,SP_RAN+46,$c0+COL_ENEMY1,12-8
	.db	24- 7,SP_RAN+48,$c0+COL_YELLOW,12-1
	.db	24- 5,SP_RAN+49,$c0+COL_YELLOW,12-9
	.db	24+ 1,SP_RAN+50,$c0+COL_YELLOW,12+0
	.db	24+ 3,SP_RAN+51,$c0+COL_YELLOW,12-8
.data19:
	.db	7
	.db	24- 5,SP_RAN+44,$c0+COL_ENEMY1,12+0
	.db	24- 5,SP_RAN+45,$c0+COL_ENEMY1,12-8
	.db	24- 8,SP_RAN+47,$c0+COL_YELLOW,12+7
	.db	24- 7,SP_RAN+48,$c0+COL_YELLOW,12-1
	.db	24- 5,SP_RAN+49,$c0+COL_YELLOW,12-9
	.db	24+ 1,SP_RAN+50,$c0+COL_YELLOW,12+0
	.db	24+ 3,SP_RAN+51,$c0+COL_YELLOW,12-8
.data20:
	.db	7
	.db	24- 8,SP_RAN+52,$c0+COL_ENEMY1,12-1
	.db	24- 1,SP_RAN+53,$c0+COL_ENEMY1,12-6
	.db	24-10,SP_RAN+54,$c0+COL_YELLOW,12-2
	.db	24- 2,SP_RAN+56,$c0+COL_YELLOW,12-3
	.db	24- 2,SP_RAN+57,$c0+COL_BLUE,  12-11
	.db	24+ 6,SP_RAN+58,$c0+COL_YELLOW,12-3
	.db	24+ 7,SP_RAN+59,$c0+COL_YELLOW,12-11
.data21:
	.db	7
	.db	24- 8,SP_RAN+52,$c0+COL_ENEMY1,12-1
	.db	24- 1,SP_RAN+53,$c0+COL_ENEMY1,12-6
	.db	24-10,SP_RAN+54,$c0+COL_YELLOW,12-2
	.db	24- 5,SP_RAN+55,$c0+COL_YELLOW,12+5
	.db	24- 2,SP_RAN+56,$c0+COL_YELLOW,12-3
	.db	24- 2,SP_RAN+57,$c0+COL_BLUE,  12-11
	.db	24+ 6,SP_RAN+58,$c0+COL_YELLOW,12-3

; eۊ֌W

	; a:p^[ԍ
	; FNC_ARG  :XW
	; FNC_ARG+1:YW
	; x: shot index
	; y: l
	; use reg : a x y
	; use work :  0-1
Shot_Item_Draw:
	sta	<FNC_WORK
	sty	<FNC_WORK+1
	ldy	#24-4

	lda	SH_T,x
	and	#$10
	beq	.1
	ldy	#24-5
	lda	<USR_CNT
	lsr	a
	bcc	.1
	ldy	#24-3
	inc	<FNC_WORK
.1:
	ldx	<SPR_INX
	lda	<FNC_WORK
	sta	SPR_DATA+1,x
	lda	<FNC_WORK+1
	sta	SPR_DATA+2,x

	lda	<FNC_ARG+1
	clc
	adc	Int,y
	sta	SPR_DATA,x

	ldy	<FNC_ARG
	lda	Int+12-4,y
	sta	SPR_DATA+3,x

	jmp	SMCL(Shot_Draw_Next)

St1_ShPutAliceA:
	cmp	#8
	ldy	SH_B,x
	lda	.pat,y
	sta	<FNC_WORK
	lda	PLC_COL2PAL,y
	bcc	.1
	eor	#$c0
.1:
	tay
	lda	<FNC_WORK
	jmp	Spr_PutShot
.pat:
	.db	SP_SHOT, SP_SHOT+1
	.db	SP_SHOT, SP_SHOT+1
	.db	SP_SHOT, SP_SHOT+1

St1_ShPutAliceB:
	jmp	SMCL(Shot_Draw_Skip)
;		cmp	#8
;		lda	PLC_COL2PAL+COL_PINK
;		bcc	.1
;		eor	#$c0
;	.1:
;		tay
;		lda	#SP_SHOT+2
;		jmp	Spr_PutShot

St1_BgDrawAliceA:
	lda	BGS_CNT3
	and	#$01
	beq	.draw1
;	bcc	.end
;	jsr	BGSeq_ClearLayerBuffer
;	jmp	.end
	rts
.draw1:
	ldx	EN_ST1_PHASE
	lda	.jmp_l,x
	sta	<FNC_WORK
	lda	.jmp_h,x
	sta	<FNC_WORK+1
	jmp	[FNC_WORK]
.jmp_l:
	.db	LOW(.drawA), LOW(.drawB)
	.db	LOW(.drawC), LOW(.drawD)
.jmp_h:
	.db	HIGH(.drawA), HIGH(.drawB)
	.db	HIGH(.drawC), HIGH(.drawD)
.drawA:
	bit	<BGS_STAT
	bmi	.drawE
	jsr	BGSeq_ClearLayerBuffer

	jmp	.drawE
.drawB:
	ldy	#0
	jsr	.ballet
	ldy	#3
	jsr	.ballet
	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB
	jmp	.drawE
.drawC:
	ldy	#1
	jsr	.ballet
	ldy	#4
	jsr	.ballet
	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB
	jmp	.drawE
.drawD:
	ldy	#2
	jsr	.ballet
	ldy	#5
	jsr	.ballet
	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB
	bit	<BGS_STAT
	bmi	.drawE
	inc	BGS_CNT3
.drawE:
	ldy	EN_ST1_PHASE
	lda	.round,y
	sta	EN_ST1_PHASE
.end:
;	lda	#1	; 
;	bne	.quit
;	lda	<BGS_UPD_CNT
;	beq	.term
;.quit:
	rts
.term:
	ldx	#(BGS_CNT3-BGS_CNT3)
	jsr	BGSeq_ClearLayerCB
	ldx	#RLF_CLR_LAYER4
	jmp	BGSeq_ReqSetHighLayer
.round:
	.db	1,2,3,0

.ballet:
	lda	EN_ST1_X,y
	bpl	.blt1
	rts
.blt1:
	ldx	EN_ST1_INX,y
	bmi	.blt2
	lda	SH_X,x
	bmi	.blt2
	lda	SH_T,x
	cmp	#$04
	beq	.blt3
.blt2:
	lda	#$fe
	sta	EN_ST1_X,y
	rts
.blt3:
	bit	<BGS_STAT
	bpl	.blt4
	tya
	tax
	jmp	.blt14
.blt4:

	sty	<FNC_WORK+8
	ldx	#$00

	lda	EN_ST1_Y,y
	clc
	adc	#2
	lsr	a
	lsr	a
	lsr	a
	bcc	.blt5
	ldx	#$04
.blt5:
	sec
	sbc	#2
	sta	<FNC_WORK+6
	clc
	adc	#4
	sta	<FNC_WORK+7

	lda	EN_ST1_X,y
	clc
	adc	#1
	lsr	a
	lsr	a
	bcc	.blt6
	inx
.blt6:
	lsr	a
	bcc	.blt7
	inx
	inx
.blt7:
	sec
	sbc	#2
	sta	<FNC_WORK+4
	clc
	adc	#5
	sta	<FNC_WORK+5

	lda	.blt_bg,x
	ldy	.blt_sft,x
	tax
.blt8:
	sty	<FNC_WORK+3
	lda	.blt_mask,y
	sta	<FNC_WORK+2

	ldy	<FNC_WORK+6
	cpy	#24
	bcc	.blt9
;	lda	<FNC_WORK+2
	and	#$03
	clc
	adc	Int,x
	tax
	jmp	.blt13
.blt9:
	lda	BGS_LAYER_L,y
	sta	<FNC_WORK
	lda	BGS_LAYER_H,y
	sta	<FNC_WORK+1

	ldy	<FNC_WORK+4
.blt10:
	asl	<FNC_WORK+2
	bcc	.blt12
	cpy	#16
	bcs	.blt11
	txa
	sta	[FNC_WORK],y
.blt11:
	inx
.blt12:
	iny
	cpy	<FNC_WORK+5
	bne	.blt10
.blt13:
	ldy	<FNC_WORK+3
	iny
	inc	<FNC_WORK+6
	lda	<FNC_WORK+6
	cmp	<FNC_WORK+7
	bne	.blt8

	ldx	<FNC_WORK+8

	lda	EN_ST1_X2,x
	sec
	sbc	<PL_X
	clc
	adc	#6
	cmp	#12
	bcs	.blt14

	lda	EN_ST1_Y2,x
	sec
	sbc	<PL_Y
	clc
	adc	#6
	cmp	#12
	bcs	.blt14

	lda	<PL_S
	ora	#$80
	sta	<PL_S
.blt14:

	ldy	EN_ST1_INX,x

	lda	EN_ST1_X2,x
	sta	SH_X,y
	lda	EN_ST1_Y2,x
	sta	SH_Y,y

	lda	EN_ST1_X,x
	sta	EN_ST1_X2,x
	lda	EN_ST1_Y,x
	sta	EN_ST1_Y2,x

	lda	EN_ST1_U,x
	clc
	adc	EN_ST1_DU,x
	sta	EN_ST1_U,x
	lda	EN_ST1_X,x
	adc	EN_ST1_DX,x
	sta	EN_ST1_X,x

	lda	EN_ST1_V,x
	clc
	adc	EN_ST1_DV,x
	sta	EN_ST1_V,x
	lda	EN_ST1_Y,x
	adc	EN_ST1_DY,x
	sta	EN_ST1_Y,x
	cmp	#$c0
	bcc	.blt15
	ror	EN_ST1_X,x
.blt15:
	lda	EN_ST1_X,x
	bpl	.blt16
	lda	#$ff
	sta	SH_X,y
.blt16:

	ldy	#0
	lda	EN_ST1_COUNT,x
	bpl	.blt17
	iny
.blt17:
	bne	.blt18
	lda	EN_ST1_A,x
	clc
	adc	.blt_angle,x
	sta	EN_ST1_A,x
.blt18:
	lda	EN_ST1_SP,x
	clc
	adc	.blt_speed,y
	bpl	.blt19
	lda	#0
.blt19:
	sta	EN_ST1_SP,x

	lda	EN_ST1_SP,x
	ldy	EN_ST1_A,x
	jsr	Util_GetRadius
	lda	<FNC_ARG
	sta	EN_ST1_DX,x
	lda	<FNC_ARG+1
	sta	EN_ST1_DY,x
	lda	<FNC_ARG+2
	sta	EN_ST1_DU,x
	lda	<FNC_ARG+3
	sta	EN_ST1_DV,x

	inc	EN_ST1_COUNT,x

	rts
.blt_mask:
	.db	$62,$f4,$f4,$62
	.db	$73,$f4,$f4,$73
	.db	$73,$73,$73,$73
	.db	$73,$7c,$7c,$73
	.db	$00,$f4,$f4,$f4
	.db	$00,$73,$f4,$73
	.db	$00,$73,$52,$73
	.db	$00,$73,$7c,$73
.blt_bg:
;	.db	$c4,$d0,$aa,$b6,$94,$a0,$82,$8a
;	82 8a 94 a0 aa b6 c4 d0
	.db	BG_ALI_SPELL+$42
	.db	BG_ALI_SPELL+$4e
	.db	BG_ALI_SPELL+$28
	.db	BG_ALI_SPELL+$34
	.db	BG_ALI_SPELL+$12
	.db	BG_ALI_SPELL+$1e
	.db	BG_ALI_SPELL+$00
	.db	BG_ALI_SPELL+$08
.blt_sft:
	.db	0,4,8,12,16,20,24,28
.blt_angle:
	.db	$95,$6b,$95,$6b,$95,$6b
.blt_speed:
	.db	$03,$fc

St2_ShPutCirnoA:
	ldy	#$03
	cmp	#8
	bcc	.1
;	and	#$07
	ldy	#$c3
.1:
	ora	#SP_CIRNO_SHOT
	jmp	Spr_PutShot

St2_ShPutLettyA:
	lda	<USR_CNT
	and	#$07
	sta	<FNC_WORK
	tay
	lda	Bit,y
	and	#$48
	cmp	#1

	lda	SH_D,x
	tay
	and	#$0f
	sta	<FNC_WORK+1
	lda	Xcn,y
	ldy	<FNC_WORK
	bcc	.1
	sta	<FNC_WORK
	jsr	Rand
	eor	<FNC_WORK
	and	#$0f
	eor	<FNC_WORK
.1:
	sta	SH_D,x

	ldx	<SPR_INX

	lda	.tile,y
	sta	SPR_DATA+1,x
	lda	#$03
	sta	SPR_DATA+2,x

	ldy	<FNC_WORK+1
;	jsr	Rand
;	and	#$0f
;	tay

	lda	<FNC_ARG+1
	clc
	adc	.ypos,y
	sta	SPR_DATA,x

	lda	<FNC_ARG
	clc
	adc	.xpos,y
	sta	SPR_DATA+3,x

	jmp	SMCL(Shot_Draw_Next)
.tile:
	.db	SP_LETTY_SHOT,   SP_LETTY_SHOT+1
	.db	SP_LETTY_SHOT+1, SP_LETTY_SHOT
	.db	SP_LETTY_SHOT+1, SP_LETTY_SHOT
	.db	SP_LETTY_SHOT,   SP_LETTY_SHOT+1
.xpos:
	.db	12-4+0, 12-4+0, 12-4-6, 12-4-8
	.db	12-4-6, 12-4+0, 12-4+6, 12-4+8
	.db	12-4+6, 12-4-2, 12-4-4, 12-4+2
	.db	12-4+4, 12-4-8, 12-4+2, 12-4+2
;	.db	12-4+0, 12-4+0, 12-4-3, 12-4-4
;	.db	12-4-3, 12-4+0, 12-4+3, 12-4+4
;	.db	12-4+3, 12-4-1, 12-4-2, 12-4+1
;	.db	12-4+2, 12-4-4, 12-4+1, 12-4+1
.ypos:
	.db	24-4+0, 24-4-8, 24-4-6, 24-4+0
	.db	24-4+6, 24-4+8, 24-4+6, 24-4+0
	.db	24-4-6, 24-4-4, 24-4+2, 24-4+4
	.db	24-4-2, 24-4-2, 24-4+8, 24-4-8
;	.db	24-4+0, 24-4-4, 24-4-3, 24-4+0
;	.db	24-4+3, 24-4+4, 24-4+3, 24-4+0
;	.db	24-4-3, 24-4-2, 24-4+1, 24-4+2
;	.db	24-4-1, 24-4-1, 24-4+4, 24-4-4

St2_ShPutLettyB:
	lda	#HIGH(EN_WORK)
	sta	<FNC_WORK+1

	lda	SH_T,x
	bmi	.2
	tay
	and	#$0f
	ora	#$80
	sta	SH_T,x
	lda	Xcn,y
	and	#$0f
	tay
	lda	.offset,y
	ora	#LOW(EN_WORK)
	sta	SH_D,x
	sta	<FNC_WORK

	ldy	#11
.1:
	lda	<FNC_ARG+1
	sta	[FNC_WORK],y
	dey
	lda	<FNC_ARG
	sta	[FNC_WORK],y
	dey
	bpl	.1
.2:
	lda	SH_D,x
	sta	<FNC_WORK

	txa
	lsr	a
	eor	<USR_CNT
	lsr	a
	bcc	.4

	lda	<FNC_WORK
;	sec
	adc	#1
	sta	<FNC_WORK+2
	lda	#HIGH(EN_WORK)
	sta	<FNC_WORK+3
	ldy	#9
.3:
	lda	[FNC_WORK],y
	sta	[FNC_WORK+2],y
	dey
	bpl	.3

	iny
	lda	<FNC_ARG
	sta	[FNC_WORK],y
	iny
	lda	<FNC_ARG+1
	sta	[FNC_WORK],y

	ldy	#7
	lda	[FNC_WORK],y
	sta	<FNC_WORK+3
	dey
	lda	[FNC_WORK],y
	sta	<FNC_WORK+2

	ldy	#3
	lda	[FNC_WORK],y
	tax
	dey
	lda	[FNC_WORK],y
	jmp	.5
.4:
	ldy	#11
	lda	[FNC_WORK],y
	sta	<FNC_WORK+3
	dey
	lda	[FNC_WORK],y
	sta	<FNC_WORK+2

	ldx	<FNC_ARG+1
	lda	<FNC_ARG
.5:
	stx	<FNC_WORK+1
	sta	<FNC_WORK

	ldx	<SPR_INX

	lda	#SP_SHOT+1
	sta	SPR_DATA+1,x
	lda	#$03
	sta	SPR_DATA+2,x

	lda	<FNC_WORK+1
	clc
	adc	#24
	sta	SPR_DATA,x

	lda	<FNC_WORK
	clc
	adc	#12
	sta	SPR_DATA+3,x

	lda	Int+4,x
	beq	.6
	tax

	lda	#SP_SHOT+1
	sta	SPR_DATA+1,x
	lda	#$03
	sta	SPR_DATA+2,x

	lda	<FNC_WORK+3
	clc
	adc	#24
	sta	SPR_DATA,x

	lda	<FNC_WORK+2
	clc
	adc	#12
	sta	SPR_DATA+3,x

	lda	Int+4,x
.6:
	jmp	SMCL(Shot_Draw_Ret)
.offset:
	.db	0,12,24,36,48,60,72,84

St4_ShPutRanB:
	lda	SH_D,x
	beq	.1
	lda	#SP_SHOT+3
	ldy	PLC_COL2PAL+COL_BLUE
	jmp	Spr_PutShot
.1:
	jmp	SMCL(Shot_Draw_Skip)


St4_BgDrawRanA:
	lda	BGS_CNT3
	and	#$01
	bne	.draw1
	bit	<BGS_STAT
	bpl	.draw2

	ldy	EN_ST4_PHASE
	lda	.round,y
	sta	EN_ST4_PHASE
	lda	#2
	sta	EN_ST4_HITCHECK
	lda	EN_ST4_PAL
	bne	.draw1
	lda	#1
	sta	EN_ST4_PAL
.draw1:
	rts
.draw2:
	lda	#BANK_PRG_DRAW2
	jsr	SetPrgBankB

	lda	EN_ST4_CMD+1
	asl	a
	asl	a
	ora	EN_ST4_PHASE
	tax
	lda	.lo,x
	sta	<FNC_WORK
	lda	.hi,x
	sta	<FNC_WORK+1
	ldy	#0

	lda	[FNC_WORK],y
	iny
	sta	<FNC_WORK+8

	lda	#2
	sta	<FNC_WORK+9
.draw3:
	ldx	<FNC_WORK+8
	lda	BGS_LAYER_L,x
	sta	<FNC_WORK+2
	lda	BGS_LAYER_H,x
	sta	<FNC_WORK+3
	lda	.inv24,x
	tax
	lda	BGS_LAYER_L,x
	sta	<FNC_WORK+4
	lda	BGS_LAYER_H,x
	sta	<FNC_WORK+5

	ldx	#16
.draw4:
	lda	[FNC_WORK],y
	iny
	sta	<FNC_WORK+6
.draw5:
	dex
	asl	<FNC_WORK+6
	lda	#$80
	bcc	.draw6
	lda	[FNC_WORK],y
	iny
.draw6:
	sty	<FNC_WORK+7
	ldy	.inv16,x
	sta	[FNC_WORK+2],y
	ldy	Int,x
	cmp	#$82
	bcc	.draw7
	eor	#$01
.draw7:
	sta	[FNC_WORK+4],y
	ldy	<FNC_WORK+7

	cpx	#8
	beq	.draw4
	txa
	bne	.draw5

	inc	<FNC_WORK+8
	dec	<FNC_WORK+9
	bpl	.draw3

	ldy	EN_ST4_PHASE
	lda	.round,y
	sta	EN_ST4_PHASE
	bne	.draw8

	ldx	EN_ST4_CMD+1
	lda	EN_ST4_BANK
	sta	BGS_BANK3
	lda	.bank,x
	sta	EN_ST4_BANK
	inc	BGS_CNT3

	lda	EN_ST4_CMD
	cmp	EN_ST4_CMD+1
	sta	EN_ST4_CMD+1
	beq	.draw8
	lda	#2
	sta	EN_ST4_HITCHECK
.draw8:
	lsr	EN_ST4_PAL
	bcc	.draw9
	lda	BGS_PAL3
	jsr	Pal_SetBGPalette
	lda	<BGC_PAL
	ora	#$02
	sta	<BGC_PAL
	lda	<BGC_REF+1
	ora	#(BGF_PALETTE)
	sta	<BGC_REF+1
.draw9:
	lda	#BANK_PRG_DATA
	jmp	SetPrgBankB
.round:
	.db	1,2,3,0
.inv24:
	.db	23,22,21,20,19,18,17,16
.inv16:
	.db	15,14,13,12,11,10, 9, 8
	.db	 7, 6, 5, 4, 3, 2, 1, 0
.bank:
	.db	BANK_CHR_SPELL+2
	.db	BANK_CHR_SPELL+2, BANK_CHR_SPELL+4
	.db	BANK_CHR_SPELL+6, BANK_CHR_SPELL+2
	.db	BANK_CHR_SPELL+8, BANK_CHR_SPELL+10
	.db	BANK_CHR_SPELL+2, BANK_CHR_SPELL+4
	.db	BANK_CHR_SPELL+6, BANK_CHR_SPELL+2
	.db	BANK_CHR_SPELL+8, BANK_CHR_SPELL+10
.lo:
	.db	LOW(St4_BgDataRanA0A)
	.db	LOW(St4_BgDataRanA0B)
	.db	LOW(St4_BgDataRanA0C)
	.db	LOW(St4_BgDataRanA0D)
	.db	LOW(St4_BgDataRanA0A)
	.db	LOW(St4_BgDataRanA0B)
	.db	LOW(St4_BgDataRanA1C)
	.db	LOW(St4_BgDataRanA1D)
	.db	LOW(St4_BgDataRanA0A)
	.db	LOW(St4_BgDataRanA0B)
	.db	LOW(St4_BgDataRanA2C)
	.db	LOW(St4_BgDataRanA2D)
	.db	LOW(St4_BgDataRanA0A)
	.db	LOW(St4_BgDataRanA0B)
	.db	LOW(St4_BgDataRanA3C)
	.db	LOW(St4_BgDataRanA3D)
	.db	LOW(St4_BgDataRanA0A)
	.db	LOW(St4_BgDataRanA4B)
	.db	LOW(St4_BgDataRanA4C)
	.db	LOW(St4_BgDataRanA4D)
	.db	LOW(St4_BgDataRanA0A)
	.db	LOW(St4_BgDataRanA0B)
	.db	LOW(St4_BgDataRanA5C)
	.db	LOW(St4_BgDataRanA5D)
	.db	LOW(St4_BgDataRanA0A)
	.db	LOW(St4_BgDataRanA0B)
	.db	LOW(St4_BgDataRanA6C)
	.db	LOW(St4_BgDataRanA6D)
	.db	LOW(St4_BgDataRanA7A)
	.db	LOW(St4_BgDataRanA7B)
	.db	LOW(St4_BgDataRanA7C)
	.db	LOW(St4_BgDataRanA7D)
	.db	LOW(St4_BgDataRanA8A)
	.db	LOW(St4_BgDataRanA8B)
	.db	LOW(St4_BgDataRanA8C)
	.db	LOW(St4_BgDataRanA8D)
	.db	LOW(St4_BgDataRanA9A)
	.db	LOW(St4_BgDataRanA9B)
	.db	LOW(St4_BgDataRanA9C)
	.db	LOW(St4_BgDataRanA9D)
	.db	LOW(St4_BgDataRanA10A)
	.db	LOW(St4_BgDataRanA10B)
	.db	LOW(St4_BgDataRanA10C)
	.db	LOW(St4_BgDataRanA10D)
	.db	LOW(St4_BgDataRanA11A)
	.db	LOW(St4_BgDataRanA11B)
	.db	LOW(St4_BgDataRanA11C)
	.db	LOW(St4_BgDataRanA11D)
	.db	LOW(St4_BgDataRanA12A)
	.db	LOW(St4_BgDataRanA12B)
	.db	LOW(St4_BgDataRanA12C)
	.db	LOW(St4_BgDataRanA12D)
.hi:
	.db	HIGH(St4_BgDataRanA0A)
	.db	HIGH(St4_BgDataRanA0B)
	.db	HIGH(St4_BgDataRanA0C)
	.db	HIGH(St4_BgDataRanA0D)
	.db	HIGH(St4_BgDataRanA0A)
	.db	HIGH(St4_BgDataRanA0B)
	.db	HIGH(St4_BgDataRanA1C)
	.db	HIGH(St4_BgDataRanA1D)
	.db	HIGH(St4_BgDataRanA0A)
	.db	HIGH(St4_BgDataRanA0B)
	.db	HIGH(St4_BgDataRanA2C)
	.db	HIGH(St4_BgDataRanA2D)
	.db	HIGH(St4_BgDataRanA0A)
	.db	HIGH(St4_BgDataRanA0B)
	.db	HIGH(St4_BgDataRanA3C)
	.db	HIGH(St4_BgDataRanA3D)
	.db	HIGH(St4_BgDataRanA0A)
	.db	HIGH(St4_BgDataRanA4B)
	.db	HIGH(St4_BgDataRanA4C)
	.db	HIGH(St4_BgDataRanA4D)
	.db	HIGH(St4_BgDataRanA0A)
	.db	HIGH(St4_BgDataRanA0B)
	.db	HIGH(St4_BgDataRanA5C)
	.db	HIGH(St4_BgDataRanA5D)
	.db	HIGH(St4_BgDataRanA0A)
	.db	HIGH(St4_BgDataRanA0B)
	.db	HIGH(St4_BgDataRanA6C)
	.db	HIGH(St4_BgDataRanA6D)
	.db	HIGH(St4_BgDataRanA7A)
	.db	HIGH(St4_BgDataRanA7B)
	.db	HIGH(St4_BgDataRanA7C)
	.db	HIGH(St4_BgDataRanA7D)
	.db	HIGH(St4_BgDataRanA8A)
	.db	HIGH(St4_BgDataRanA8B)
	.db	HIGH(St4_BgDataRanA8C)
	.db	HIGH(St4_BgDataRanA8D)
	.db	HIGH(St4_BgDataRanA9A)
	.db	HIGH(St4_BgDataRanA9B)
	.db	HIGH(St4_BgDataRanA9C)
	.db	HIGH(St4_BgDataRanA9D)
	.db	HIGH(St4_BgDataRanA10A)
	.db	HIGH(St4_BgDataRanA10B)
	.db	HIGH(St4_BgDataRanA10C)
	.db	HIGH(St4_BgDataRanA10D)
	.db	HIGH(St4_BgDataRanA11A)
	.db	HIGH(St4_BgDataRanA11B)
	.db	HIGH(St4_BgDataRanA11C)
	.db	HIGH(St4_BgDataRanA11D)
	.db	HIGH(St4_BgDataRanA12A)
	.db	HIGH(St4_BgDataRanA12B)
	.db	HIGH(St4_BgDataRanA12C)
	.db	HIGH(St4_BgDataRanA12D)

